--***                     Assembly code used in m19lib. 		      ***--
--***                        Written 98/99 by Mic.         		      ***-- 


include asm.e


--*** Variables for use with hline drawer ***--
--*** There are 200 lines on the screen, 200 DWORDS makes 800 bytes... ***--
global constant asm_xmin=allocate(800),		
                asm_xmax=allocate(800)

  

--*** Plain display ***--
global constant asm_disp_code=get_asm(
"pusha cld "&
"mov eax,asm_disp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_disp_x "&
"add ebx,disp_screen_addr "&
"mov edi,ebx "&
"mov ebx,bmp_img_addr "&
"mov esi,ebx "&
"mov ebx,odd_pixel "&
"mov edx,bmp_ydim "&
"xor eax,eax "&
"asmDispLoop: "&
"mov ecx,bmp_xdim "&
"rep movsw "&
"cmp bl,0 "&
"je no_odd_pixel "&
"movsb "&
"no_odd_pixel: "&
"inc eax "&
"cmp eax,edx "&
"je asmDispDone "&
"add edi,disp_offs_add "&
"jmp asmDispLoop "&
"asmDispDone: "&
"popa ret ")
global constant asm_disp_x=asm_disp_code+get_param("asm_disp_x")
global constant asm_disp_y=asm_disp_code+get_param("asm_disp_y")
global constant disp_screen_addr=asm_disp_code+get_param("disp_screen_addr")
global constant bmp_img_addr=asm_disp_code+get_param("bmp_img_addr")
global constant bmp_xdim=asm_disp_code+get_param("bmp_xdim")
global constant bmp_ydim=asm_disp_code+get_param("bmp_ydim")
global constant disp_offs_add=asm_disp_code+get_param("disp_offs_add")
global constant odd_pixel=asm_disp_code+get_param("odd_pixel")


--*** Display a dword-aligned sprite ***--
global constant asm_d_disp_code=get_asm(
"pusha cld "&
"mov eax,d_asm_disp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,d_asm_disp_x "&
"add ebx,d_disp_screen_addr "&
"mov edi,ebx "&
"mov ebx,d_bmp_img_addr "&
"mov esi,ebx "&
"mov edx,d_bmp_ydim "&
"xor eax,eax "&
"d_asmDispLoop: "&
"mov ecx,d_bmp_xdim "&
"rep movsd "&
"inc eax "&
"cmp eax,edx "&
"je d_asmDispDone "&
"add edi,d_disp_offs_add "&
"jmp d_asmDispLoop "&
"d_asmDispDone: "&
"popa ret ")
global constant d_asm_disp_x=asm_d_disp_code+get_param("d_asm_disp_x")
global constant d_asm_disp_y=asm_d_disp_code+get_param("d_asm_disp_y")
global constant d_disp_screen_addr=asm_d_disp_code+get_param("d_disp_screen_addr")
global constant d_bmp_img_addr=asm_d_disp_code+get_param("d_bmp_img_addr")
global constant d_bmp_xdim=asm_d_disp_code+get_param("d_bmp_xdim")
global constant d_bmp_ydim=asm_d_disp_code+get_param("d_bmp_ydim")
global constant d_disp_offs_add=asm_d_disp_code+get_param("d_disp_offs_add")


--*** Display a word-aligned sprite ***--
global constant asm_w_disp_code=get_asm(
"pusha cld "&
"mov eax,w_asm_disp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,w_asm_disp_x "&
"add ebx,w_disp_screen_addr "&
"mov edi,ebx "&
"mov ebx,w_bmp_img_addr "&
"mov esi,ebx "&
"mov edx,w_bmp_ydim "&
"xor eax,eax "&
"w_asmDispLoop: "&
"mov ecx,w_bmp_xdim "&
"rep movsw "&
"inc eax "&
"cmp eax,edx "&
"je w_asmDispDone "&
"add edi,w_disp_offs_add "&
"jmp w_asmDispLoop "&
"w_asmDispDone: "&
"popa ret ")
global constant w_asm_disp_x=asm_w_disp_code+get_param("w_asm_disp_x")
global constant w_asm_disp_y=asm_w_disp_code+get_param("w_asm_disp_y")
global constant w_disp_screen_addr=asm_w_disp_code+get_param("w_disp_screen_addr")
global constant w_bmp_img_addr=asm_w_disp_code+get_param("w_bmp_img_addr")
global constant w_bmp_xdim=asm_w_disp_code+get_param("w_bmp_xdim")
global constant w_bmp_ydim=asm_w_disp_code+get_param("w_bmp_ydim")
global constant w_disp_offs_add=asm_w_disp_code+get_param("w_disp_offs_add")


--*** Display a sprite using one single color ***--
global constant asm_cdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_cdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_cdisp_x "&
"add ebx,cdisp_screen_addr "&
"mov edi,ebx "&
"mov ebx,codd_pixel "&
"mov edx,0 "&
"mov edx,cbmp_ydim "&
"xor eax,eax "&
"asmcDispLoop: "&
"mov ecx,cbmp_xdim "&
"mov eax,c_color "&
"rep stosw "&
"cmp bl,0 "&
"je cno_odd_pixel "&
"stosb "&
"cno_odd_pixel: "&
"inc dh "&
"cmp dh,dl "&
"je asmcDispDone "&
"add edi,cdisp_offs_add "&
"jmp asmcDispLoop "&
"asmcDispDone: "&
"popa ret ")
global constant asm_cdisp_x=asm_cdisp_code+get_param("asm_cdisp_x")
global constant asm_cdisp_y=asm_cdisp_code+get_param("asm_cdisp_y")
global constant cdisp_screen_addr=asm_cdisp_code+get_param("cdisp_screen_addr")
global constant cbmp_xdim=asm_cdisp_code+get_param("cbmp_xdim")
global constant cbmp_ydim=asm_cdisp_code+get_param("cbmp_ydim")
global constant cdisp_offs_add=asm_cdisp_code+get_param("cdisp_offs_add")
global constant c_color=asm_cdisp_code+get_param("c_color")
global constant codd_pixel=asm_cdisp_code+get_param("codd_pixel")


--*** Display a scaled sprite ***--
global constant asm_scale_disp_code=get_asm(
"pusha cld "&
"mov eax,asm_sdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_sdisp_x "&
"add ebx,sdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,sbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,sbmp_img_addr "&
"asmsDispLoop: "&
"mov ecx,sbmp_xdim "&
"asmsXloop: "&
"mov esi,sbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"movsb "&
"mov ebx,eax "&
"mov eax,spriteXstep "&
"add ebx,eax "&
"loop asmsXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmsDispDone "&
"inc dh "&
"push edx "&
"add edi,sdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,spriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,sspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmsDispLoop "&
"asmsDispDone: "&
"popa ret ")
global constant asm_sdisp_x=asm_scale_disp_code+get_param("asm_sdisp_x")
global constant asm_sdisp_y=asm_scale_disp_code+get_param("asm_sdisp_y")
global constant sdisp_screen_addr=asm_scale_disp_code+get_param("sdisp_screen_addr")
global constant sbmp_img_addr=asm_scale_disp_code+get_param("sbmp_img_addr")
global constant sbmp_xdim=asm_scale_disp_code+get_param("sbmp_xdim")
global constant sbmp_ydim=asm_scale_disp_code+get_param("sbmp_ydim")
global constant sdisp_offs_add=asm_scale_disp_code+get_param("sdisp_offs_add")
global constant spriteXstep=asm_scale_disp_code+get_param("spriteXstep")
global constant spriteYstep=asm_scale_disp_code+get_param("spriteYstep")
global constant sspriteXdims=asm_scale_disp_code+get_param("sspriteXdims")


--*** Display a scaled semi-transparent sprite ***--
global constant asm_scale_tdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_stdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_stdisp_x "&
"add ebx,stdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,stbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,stbmp_img_addr "&
"asmstDispLoop: "&
"mov ecx,stbmp_xdim "&
"asmstXloop: "&
"mov esi,stbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"lodsb "&
"cmp al,0 "&
"je st_black_pixel "&
"stosb "&
"jmp st_noadd "&
"st_black_pixel: "&
"inc edi "&
"st_noadd: "&
"mov ebx,eax "&
"mov eax,tspriteXstep "&
"add ebx,eax "&
"loop asmstXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmstDispDone "&
"inc dh "&
"push edx "&
"add edi,stdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,tspriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,stspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmstDispLoop "&
"asmstDispDone: "&
"popa ret ")
global constant asm_stdisp_x=asm_scale_tdisp_code+get_param("asm_stdisp_x")
global constant asm_stdisp_y=asm_scale_tdisp_code+get_param("asm_stdisp_y")
global constant stdisp_screen_addr=asm_scale_tdisp_code+get_param("stdisp_screen_addr")
global constant stbmp_img_addr=asm_scale_tdisp_code+get_param("stbmp_img_addr")
global constant stbmp_xdim=asm_scale_tdisp_code+get_param("stbmp_xdim")
global constant stbmp_ydim=asm_scale_tdisp_code+get_param("stbmp_ydim")
global constant stdisp_offs_add=asm_scale_tdisp_code+get_param("stdisp_offs_add")
global constant tspriteXstep=asm_scale_tdisp_code+get_param("tspriteXstep")
global constant tspriteYstep=asm_scale_tdisp_code+get_param("tspriteYstep")
global constant stspriteXdims=asm_scale_tdisp_code+get_param("stspriteXdims")


--*** Display a semi-transparent sprite ***--
global constant asm_tdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_tdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_tdisp_x "&
"add ebx,tdisp_screen_addr "&
"mov edi,ebx "&
"mov ebx,tbmp_img_addr "&
"mov esi,ebx "&
"mov edx,tbmp_ydim "&
"xor ebx,ebx "&
"asmtDispLoop: "&
"mov ecx,tbmp_xdim "&
"asmtDispLoop2: "&
"lodsb "&
"cmp al,0 "&
"je tblack_pixel "&
"stosb "&
"jmp tno_add "&
"tblack_pixel: "&
"inc edi "&
"tno_add: "&
"loop asmtDispLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmtDispDone "&
"add edi,tdisp_offs_add "&
"jmp asmtDispLoop "&
"asmtDispDone: "&
"popa ret ")
global constant asm_tdisp_x=asm_tdisp_code+get_param("asm_tdisp_x")
global constant asm_tdisp_y=asm_tdisp_code+get_param("asm_tdisp_y")
global constant tdisp_screen_addr=asm_tdisp_code+get_param("tdisp_screen_addr")
global constant tbmp_img_addr=asm_tdisp_code+get_param("tbmp_img_addr")
global constant tbmp_xdim=asm_tdisp_code+get_param("tbmp_xdim")
global constant tbmp_ydim=asm_tdisp_code+get_param("tbmp_ydim")
global constant tdisp_offs_add=asm_tdisp_code+get_param("tdisp_offs_add")


--*** Display a semi-transparent monochrome sprite ***--
global constant asm_ctdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_ctdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_ctdisp_x "&
"add ebx,ctdisp_screen_addr "&
"mov edi,ebx "&
"mov ebx,ctbmp_img_addr "&
"mov esi,ebx "&
"mov edx,ctbmp_ydim "&
"xor ebx,ebx "&
"asmctDispLoop: "&
"mov ecx,ctbmp_xdim "&
"asmctDispLoop2: "&
"lodsb "&
"cmp al,0 "&
"je cblackPixel "&
"mov eax,ct_color "&
"stosb "&
"jmp ctno_add "&
"cblackPixel: "&
"inc edi "&
"ctno_add: "&
"loop asmctDispLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmctDispDone "&
"add edi,ctdisp_offs_add "&
"jmp asmctDispLoop "&
"asmctDispDone: "&
"popa ret ")
global constant asm_ctdisp_x=asm_ctdisp_code+get_param("asm_ctdisp_x")
global constant asm_ctdisp_y=asm_ctdisp_code+get_param("asm_ctdisp_y")
global constant ctdisp_screen_addr=asm_ctdisp_code+get_param("ctdisp_screen_addr")
global constant ctbmp_img_addr=asm_ctdisp_code+get_param("ctbmp_img_addr")
global constant ctbmp_xdim=asm_ctdisp_code+get_param("ctbmp_xdim")
global constant ctbmp_ydim=asm_ctdisp_code+get_param("ctbmp_ydim")
global constant ctdisp_offs_add=asm_ctdisp_code+get_param("ctdisp_offs_add")
global constant ct_color=asm_ctdisp_code+get_param("ct_color")


--*** Display a dword-aligned clipped sprite ***--
global constant asm_d_dispclip_code=get_asm(
"pusha cld "&
"mov eax,d_asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,d_asm_dispclip_x "&
"add ebx,d_dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,d_clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,d_clipbmp_ydim "&
"xor eax,eax "&
"d_asmDispclipLoop: "&
"mov ecx,d_clipbmp_xdim "&
"rep movsd "&
"inc eax "&
"cmp eax,edx "&
"je d_asmDispclipDone "&
"add edi,d_dispclip_offs_add "&
"add esi,d_clipimg_offs_add "&
"jmp d_asmDispclipLoop "&
"d_asmDispclipDone: "&
"popa ret ")
global constant d_asm_dispclip_x=asm_d_dispclip_code+get_param("d_asm_dispclip_x")
global constant d_asm_dispclip_y=asm_d_dispclip_code+get_param("d_asm_dispclip_y")
global constant d_dispclip_screen_addr=asm_d_dispclip_code+get_param("d_dispclip_screen_addr")
global constant d_clipbmp_img_addr=asm_d_dispclip_code+get_param("d_clipbmp_img_addr")
global constant d_clipbmp_xdim=asm_d_dispclip_code+get_param("d_clipbmp_xdim")
global constant d_clipbmp_ydim=asm_d_dispclip_code+get_param("d_clipbmp_ydim")
global constant d_dispclip_offs_add=asm_d_dispclip_code+get_param("d_dispclip_offs_add")
global constant d_clipimg_offs_add=asm_d_dispclip_code+get_param("d_clipimg_offs_add")


--*** Display a word-aligned clipped sprite ***--
global constant asm_w_dispclip_code=get_asm(
"pusha cld "&
"mov eax,w_asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,w_asm_dispclip_x "&
"add ebx,w_dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,w_clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,w_clipbmp_ydim "&
"xor eax,eax "&
"w_asmDispclipLoop: "&
"mov ecx,w_clipbmp_xdim "&
"rep movsw "&
"inc eax "&
"cmp eax,edx "&
"je w_asmDispclipDone "&
"add edi,w_dispclip_offs_add "&
"add esi,w_clipimg_offs_add "&
"jmp w_asmDispclipLoop "&
"w_asmDispclipDone: "&
"popa ret ")
global constant w_asm_dispclip_x=asm_w_dispclip_code+get_param("w_asm_dispclip_x")
global constant w_asm_dispclip_y=asm_w_dispclip_code+get_param("w_asm_dispclip_y")
global constant w_dispclip_screen_addr=asm_w_dispclip_code+get_param("w_dispclip_screen_addr")
global constant w_clipbmp_img_addr=asm_w_dispclip_code+get_param("w_clipbmp_img_addr")
global constant w_clipbmp_xdim=asm_w_dispclip_code+get_param("w_clipbmp_xdim")
global constant w_clipbmp_ydim=asm_w_dispclip_code+get_param("w_clipbmp_ydim")
global constant w_dispclip_offs_add=asm_w_dispclip_code+get_param("w_dispclip_offs_add")
global constant w_clipimg_offs_add=asm_w_dispclip_code+get_param("w_clipimg_offs_add")



--*** Display a clipped sprite ***--
global constant asm_dispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_dispclip_x "&
"add ebx,dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,clipbmp_ydim "&
"xor eax,eax "&
"asmDispclipLoop: "&
"mov ecx,clipbmp_xdim "&
"rep movsw "&
"movsb "&
"inc eax "&
"cmp eax,edx "&
"je asmDispclipDone "&
"add edi,dispclip_offs_add "&
"add esi,clipimg_offs_add "&
"jmp asmDispclipLoop "&
"asmDispclipDone: "&
"popa ret ")
global constant asm_dispclip_x=asm_dispclip_code+get_param("asm_dispclip_x")
global constant asm_dispclip_y=asm_dispclip_code+get_param("asm_dispclip_y")
global constant dispclip_screen_addr=asm_dispclip_code+get_param("dispclip_screen_addr")
global constant clipbmp_img_addr=asm_dispclip_code+get_param("clipbmp_img_addr")
global constant clipbmp_xdim=asm_dispclip_code+get_param("clipbmp_xdim")
global constant clipbmp_ydim=asm_dispclip_code+get_param("clipbmp_ydim")
global constant dispclip_offs_add=asm_dispclip_code+get_param("dispclip_offs_add")
global constant clipimg_offs_add=asm_dispclip_code+get_param("clipimg_offs_add")


--*** Display a scaled clipped sprite ***--
global constant asm_scale_disp_clip_code=get_asm(
"pusha cld "&
"mov eax,asm_scdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_scdisp_x "&
"add ebx,scdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,scbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,scbmp_img_addr "&
"asmscDispLoop: "&
"mov ecx,scbmp_xdim "&
"asmscXloop: "&
"mov esi,scbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"movsb "&
"mov ebx,eax "&
"mov eax,cspriteXstep "&
"add ebx,eax "&
"loop asmscXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmscDispDone "&
"inc dh "&
"push edx "&
"add edi,scdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,cspriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,scspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmscDispLoop "&
"asmscDispDone: "&
"popa ret ")
global constant asm_scdisp_x=asm_scale_disp_clip_code+get_param("asm_scdisp_x")
global constant asm_scdisp_y=asm_scale_disp_clip_code+get_param("asm_scdisp_y")
global constant scdisp_screen_addr=asm_scale_disp_clip_code+get_param("scdisp_screen_addr")
global constant scbmp_img_addr=asm_scale_disp_clip_code+get_param("scbmp_img_addr")
global constant scbmp_xdim=asm_scale_disp_clip_code+get_param("scbmp_xdim")
global constant scbmp_ydim=asm_scale_disp_clip_code+get_param("scbmp_ydim")
global constant scdisp_offs_add=asm_scale_disp_clip_code+get_param("scdisp_offs_add")
global constant cspriteXstep=asm_scale_disp_clip_code+get_param("cspriteXstep")
global constant cspriteYstep=asm_scale_disp_clip_code+get_param("cspriteYstep")
global constant scspriteXdims=asm_scale_disp_clip_code+get_param("scspriteXdims")


--*** Display a scaled semi-transparent clipped sprite ***--
global constant asm_scale_tdisp_clip_code=get_asm(
"pusha cld "&
"mov eax,asm_stcdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_stcdisp_x "&
"add ebx,stcdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,stcbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,stcbmp_img_addr "&
"asmstcDispLoop: "&
"mov ecx,stcbmp_xdim "&
"asmstcXloop: "&
"mov esi,stcbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"lodsb "&
"cmp al,0 "&
"je stc_black_pixel "&
"stosb "&
"jmp stc_noadd "&
"stc_black_pixel: "&
"inc edi "&
"stc_noadd: "&
"mov ebx,eax "&
"mov eax,tcspriteXstep "&
"add ebx,eax "&
"loop asmstcXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmstcDispDone "&
"inc dh "&
"push edx "&
"add edi,stcdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,tcspriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,stcspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmstcDispLoop "&
"asmstcDispDone: "&
"popa ret ")
global constant asm_stcdisp_x=asm_scale_tdisp_clip_code+get_param("asm_stcdisp_x")
global constant asm_stcdisp_y=asm_scale_tdisp_clip_code+get_param("asm_stcdisp_y")
global constant stcdisp_screen_addr=asm_scale_tdisp_clip_code+get_param("stcdisp_screen_addr")
global constant stcbmp_img_addr=asm_scale_tdisp_clip_code+get_param("stcbmp_img_addr")
global constant stcbmp_xdim=asm_scale_tdisp_clip_code+get_param("stcbmp_xdim")
global constant stcbmp_ydim=asm_scale_tdisp_clip_code+get_param("stcbmp_ydim")
global constant stcdisp_offs_add=asm_scale_tdisp_clip_code+get_param("stcdisp_offs_add")
global constant tcspriteXstep=asm_scale_tdisp_clip_code+get_param("tcspriteXstep")
global constant tcspriteYstep=asm_scale_tdisp_clip_code+get_param("tcspriteYstep")
global constant stcspriteXdims=asm_scale_tdisp_clip_code+get_param("stcspriteXdims")


--*** Display a monochrome clipped sprite ***--
global constant asm_cdispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_cdispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_cdispclip_x "&
"add ebx,cdispclip_screen_addr "&
"mov edi,ebx "&
"mov edx,cclipbmp_ydim "&
"mov ebx,cclip_odd_pixel "&
"xor eax,eax "&
"asmcDispclipLoop: "&
"mov ecx,cclipbmp_xdim "&
"push eax "&
"mov eax,cclip_color "&
"rep stosw "&
"cmp bl,0 "&
"je cclip_no_odd_pixel "&
"stosb "&
"cclip_no_odd_pixel: "&
"pop eax "&
"inc eax "&
"cmp eax,edx "&
"je asmcDispclipDone "&
"add edi,cdispclip_offs_add "&
"jmp asmcDispclipLoop "&
"asmcDispclipDone: "&
"popa ret ")
global constant asm_cdispclip_x=asm_cdispclip_code+get_param("asm_cdispclip_x")
global constant asm_cdispclip_y=asm_cdispclip_code+get_param("asm_cdispclip_y")
global constant cdispclip_screen_addr=asm_cdispclip_code+get_param("cdispclip_screen_addr")
global constant cclipbmp_xdim=asm_cdispclip_code+get_param("cclipbmp_xdim")
global constant cclipbmp_ydim=asm_cdispclip_code+get_param("cclipbmp_ydim")
global constant cdispclip_offs_add=asm_cdispclip_code+get_param("cdispclip_offs_add")
global constant cclip_color=asm_cdispclip_code+get_param("cclip_color")
global constant cclip_odd_pixel=asm_cdispclip_code+get_param("cclip_odd_pixel")


--*** Display a semi-transparent clipped sprite ***--
global constant asm_tdispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_tdispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_tdispclip_x "&
"add ebx,tdispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,tclipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,tclipbmp_ydim "&
"xor ebx,ebx "&
"asmtDispclipLoop: "&
"mov ecx,tclipbmp_xdim "&
"asmtDispclipLoop2: "&
"lodsb "&
"cmp al,0 "&
"je tclip_black_pixel "&
"stosb "&
"jmp tclip_no_add "&
"tclip_black_pixel: "&
"inc edi "&
"tclip_no_add: "&
"loop asmtDispclipLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmtDispclipDone "&
"add edi,tdispclip_offs_add "&
"add esi,tclipimg_offs_add "&
"jmp asmtDispclipLoop "&
"asmtDispclipDone: "&
"popa ret ")
global constant asm_tdispclip_x=asm_tdispclip_code+get_param("asm_tdispclip_x")
global constant asm_tdispclip_y=asm_tdispclip_code+get_param("asm_tdispclip_y")
global constant tdispclip_screen_addr=asm_tdispclip_code+get_param("tdispclip_screen_addr")
global constant tclipbmp_img_addr=asm_tdispclip_code+get_param("tclipbmp_img_addr")
global constant tclipbmp_xdim=asm_tdispclip_code+get_param("tclipbmp_xdim")
global constant tclipbmp_ydim=asm_tdispclip_code+get_param("tclipbmp_ydim")
global constant tdispclip_offs_add=asm_tdispclip_code+get_param("tdispclip_offs_add")
global constant tclipimg_offs_add=asm_tdispclip_code+get_param("tclipimg_offs_add")


--*** Display a monochrome semi-transparent clipped sprite ***--
global constant asm_ctdispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_ctdispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_ctdispclip_x "&
"add ebx,ctdispclip_screen_addr "&
"mov edi,ebx "&
"mov edx,ctclipbmp_ydim "&
"mov ebx,ctclipbmp_img_addr "&
"mov esi,ebx "&
"xor ebx,ebx "&
"asmctDispclipLoop: "&
"mov ecx,ctclipbmp_xdim "&
"asmctDispclipLoop2: "&
"lodsb "&
"cmp al,0 "&
"je ctClipBlack "&
"mov eax,ctclip_color "&
"stosb "&
"jmp ctclip_no_add "&
"ctClipBlack: "&
"inc edi "&
"ctclip_no_add: "&
"loop asmctDispclipLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmctDispclipDone "&
"add edi,ctdispclip_offs_add "&
"add esi,ctclipimg_offs_add "&
"jmp asmctDispclipLoop "&
"asmctDispclipDone: "&
"popa ret ")
global constant asm_ctdispclip_x=asm_ctdispclip_code+get_param("asm_ctdispclip_x")
global constant asm_ctdispclip_y=asm_ctdispclip_code+get_param("asm_ctdispclip_y")
global constant ctdispclip_screen_addr=asm_ctdispclip_code+get_param("ctdispclip_screen_addr")
global constant ctclipbmp_xdim=asm_ctdispclip_code+get_param("ctclipbmp_xdim")
global constant ctclipbmp_ydim=asm_ctdispclip_code+get_param("ctclipbmp_ydim")
global constant ctdispclip_offs_add=asm_ctdispclip_code+get_param("ctdispclip_offs_add")
global constant ctclip_color=asm_ctdispclip_code+get_param("ctclip_color")
global constant ctclipbmp_img_addr=asm_ctdispclip_code+get_param("ctclipbmp_img_addr")
global constant ctclipimg_offs_add=asm_ctdispclip_code+get_param("ctclipimg_offs_add")


--*** Clear the screen ***--
global constant asm_cls_code=get_asm(
"pusha cld "&
"mov edi,cls_screen_addr "&
"mov eax,asm_cls_color "&
"mov ecx,16000 "&
"rep stosd "&
"popa ret ")
global constant cls_screen_addr=asm_cls_code+get_param("cls_screen_addr")
global constant asm_cls_color=asm_cls_code+get_param("asm_cls_color")


--*** Draw a line ***--
global constant asm_line_code=get_asm(
"pusha cld "&
"mov edi,line_dest "&
"mov edx,line_d "&
"mov al,line_color "&
"mov ecx,line_numPixels "&
"mov ebx,line_dInc1 "&
"bres1: "&
"stosb "&
"cmp edx,0 "&
"jnl bres2 "&
"add edx,ebx "&
"add edi,line_screenInc1 "&
"jmp bres3 "&
"bres2: "&
"add edx,line_dInc2 "&
"add edi,line_screenInc2 "&
"bres3: "&
"loop bres1 "&
"popa ret")
global constant line_dest=asm_line_code+get_param("line_dest")
global constant line_color=asm_line_code+get_param("line_color")
global constant line_numPixels=asm_line_code+get_param("line_numPixels")
global constant line_dInc1=asm_line_code+get_param("line_dInc1")
global constant line_dInc2=asm_line_code+get_param("line_dInc2")
global constant line_screenInc1=asm_line_code+get_param("line_screenInc1")
global constant line_screenInc2=asm_line_code+get_param("line_screenInc2")
global constant line_d=asm_line_code+get_param("line_d")


--*** Copy one screen to another ***--
global constant copy_screen_code=get_asm(
"pusha cld "&
"mov edi,copy_dest_addr "&
"mov esi,copy_src_addr "&
"mov ecx,16000 "&
"rep movsd "&
"popa ret ")
global constant copy_dest_addr=copy_screen_code+get_param("copy_dest_addr")
global constant copy_src_addr=copy_screen_code+get_param("copy_src_addr")


--*** Copy one screen to another, with scanlines ***--
global constant copy_screen_scan_code=get_asm(
"pusha cld "&
"mov eax,scan_color "&
"mov edi,scan_copy_dest "&
"mov esi,scan_copy_src "&
"mov dl,0 "&
"scan_copy_loop: "&
"mov ecx,80 "&
"rep movsd "&
"mov ecx,80 "&
"rep stosd "&
"inc dl "&
"cmp dl,100 "&
"je scan_copy_done "&
"add esi,320 "&
"jmp scan_copy_loop "&
"scan_copy_done: "&
"popa ret")
global constant scan_copy_dest=copy_screen_scan_code+get_param("scan_copy_dest")
global constant scan_copy_src=copy_screen_scan_code+get_param("scan_copy_src")
global constant scan_copy_color=copy_screen_scan_code+get_param("scan_color")


global constant copy_screen_mask_code=get_asm(
"pusha cld "&
"mov esi,mask_copy_src "&
"mov edi,mask_copy_dest "&
"mov ecx,64000 "&
"mov ebx,0 "&
"mask_loop: "&
"mov eax,[mask_copy_mask + ebx] "&
"cmp al,0 "&
"je mask_noDraw "&
"movsb "&
"jmp mask_noAdd "&
"mask_noDraw: "&
"inc esi "&
"inc edi "&
"mask_noAdd: "&
"inc ebx "&
"loop mask_loop "&
"popa ret")
global constant mask_copy_src=copy_screen_mask_code+get_param("mask_copy_src")
global constant mask_copy_dest=copy_screen_mask_code+get_param("mask_copy_dest")
global constant mask_copy_mask=copy_screen_mask_code+get_param("mask_copy_mask")


--*** Wait for a vertical retrace ***--
global constant wait_vrt_code=get_asm(
"pusha cld "&
"mov edx,986 "&
"waitLbl1: "&
"in ax,dx "&
"and al,8 "&
"jnz waitLbl1 "&
"waitLbl2: "&
"in ax,dx "&
"and al,8 "&
"jz waitLbl2 "&
"popa ret")


--*** Wait for a partial vertical retrace ***--
global constant short_wait_vrt_code=get_asm(
"pusha cld "&
"mov edx,986 "&
"shortwaitLbl1: "&
"in ax,dx "&
"and al,1 "&
"jnz shortwaitLbl1 "&
"shortwaitLbl2: "&
"in ax,dx "&
"and al,1 "&
"jz shortwaitLbl2 "&
"popa ret")


--*** Draw a number of horizontal lines (for use with poly-drawers). ***--
global constant hlines_code=get_asm(
"pusha cld "&
"mov ecx,hline_ylen "&
"mov edx,hline_y "&
"mov ebx,edx "&
"dec ebx "&
"shl ebx,3 "&
"yloop: "&
"push ecx "&
"push edx "&
"shl edx,6 "&
"mov edi,edx "&
"shl edx,2 "&
"add edi,edx "&
"mov eax,hline_scraddr "&
"add edi,eax "&
"mov eax,[asm_xmin + ebx] "&
"add edi,eax "&
"mov ecx,[asm_xmax + ebx] "&
"add ebx,4 "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,hline_col "&
"rep stosb "&
"pop edx "&
"pop ecx "&
"inc edx "&
"dec ecx "&
"jnz yloop "&
"popa ret")
global constant hline_ylen=hlines_code+get_param("hline_ylen")
global constant hline_y=hlines_code+get_param("hline_y")
global constant hline_scraddr=hlines_code+get_param("hline_scraddr")
global constant hline_col=hlines_code+get_param("hline_col")
resolve_param("asm_xmax",hlines_code,asm_xmax)
resolve_param("asm_xmin",hlines_code,asm_xmin)


global constant asm_box_code=get_asm(
"pusha cld "&
"mov eax,asm_boxCol "&
"mov ecx,asm_box_yDim "&
"mov edi,asm_boxAddr "&
"box_yloop: "&
"push ecx "&
"mov ecx,asm_box_xDim "&
"rep stosb "&
"add edi,asm_box_add "&
"pop ecx "&
"loop box_yloop "&
"popa ret")
global constant asm_boxCol=asm_box_code+get_param("asm_boxCol")
global constant asm_boxAddr=asm_box_code+get_param("asm_boxAddr")
global constant asm_box_xDim=asm_box_code+get_param("asm_box_xDim")
global constant asm_box_yDim=asm_box_code+get_param("asm_box_yDim")
global constant asm_box_add=asm_box_code+get_param("asm_box_add")


global constant asm_char_code=get_asm(
"pusha cld "&
"mov dh,asm_char_ydim "&
"mov dl,0 "&
"mov esi,asm_char_charAddr "&
"mov edi,asm_char_scrAddr "&
"mov al,asm_char_color "&
"asm_char_yloop: "&
"mov ecx,asm_char_xdim "&
"asm_char_xloop: "&
"mov bl,[esi] "&
"cmp bl,0 "&
"je charNoDraw "&
"stosb "&
"jmp charNoInc "&
"charNoDraw: "&
"inc edi "&
"charNoInc: "&
"inc esi "&
"loop asm_char_xloop "&
"add edi,asm_char_ediAdd "&
"add esi,asm_char_esiAdd "&
"inc dl "&
"cmp dl,dh "&
"jne asm_char_yloop "&
"popa ret")
global constant asm_char_ydim=asm_char_code+get_param("asm_char_ydim")
global constant asm_char_xdim=asm_char_code+get_param("asm_char_xdim")
global constant asm_char_color=asm_char_code+get_param("asm_char_color")
global constant asm_char_charAddr=asm_char_code+get_param("asm_char_charAddr")
global constant asm_char_scrAddr=asm_char_code+get_param("asm_char_scrAddr")
global constant asm_char_esiAdd=asm_char_code+get_param("asm_char_esiAdd")
global constant asm_char_ediAdd=asm_char_code+get_param("asm_char_ediAdd")


