--*** Two spinning cones using m19lib ***--

include m19lib.e


sequence points,points2,faces,faces2,order
sequence pal
integer v
atom vscreen
atom time1,time2,frames

vscreen=allocate(64000)

--*** This is the points of the cones ***--
points2={
 {-1,-1,-1},
 {1,-1,-1},
 {0,1,-1},
 {0,0,1}
}
points2=points2*30

--*** Set up the palette ***--
pal=repeat({0,0,0},256)
for i=1 to 63 do
 pal[i]={(i-1),0,0}
 pal[63+i]={(i-1),(i-1),63}
end for

--*** Set mode 19, set the palette and create a lookup table for sin and cos ***--
set_vga()
set_pal(pal)
make_trigTb()

v=1
frames=0
time1=time()

while get_key()=-1 do
 mem_cls(vscreen,0)
 --*** Rotate the points ***--
 points=rotate(points2,{1,1,1},{v,v,v})
 --*** Create the faces ***--
 faces={
  points[1..3],
  {points[1],points[2],points[4]},
  {points[2],points[3],points[4]},
  {points[3],points[1],points[4]}
 }
 --*** Sort the faces ***--
 order=sort_faces(faces)
 --*** Get screen-coordinates for the two cones ***--
 faces2=get_screen_xy({90,175},faces)
 faces=get_screen_xy({300,100},faces)
 --*** There are 4 faces... ***--
 for i=1 to 4 do
   asm_tri(faces[order[i]],1,54+(i*2),vscreen)
   asm_tri(faces2[order[i]],1,65+(i*3),vscreen)
 end for
 --*** Wait for a vertical retrace, then copy the virtual screen to the real screen ***--
 wait_vrt()
 asm_copy_screen(vscreen,#A0000)
 frames=frames+1
 --*** Increase angle ***--
 v=v+1
 if v>=361 then
  v=1
 end if
end while
time2=time()

restore_graphics()
free_asm_code()
free(vscreen)

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))
