--*** Flat-shaded cube using m19lib ***--

include m19lib.e


sequence points,points2,faces,order,zNormals
sequence pal
sequence v,dv	
integer faceCol
atom shade
atom vscreen
atom time1,time2,frames

vscreen=allocate(64000)

points2={
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}
points2=points2*35

pal=repeat({0,0,0},256)
for i=1 to 63 do
 pal[i]={(i-1),0,0}
end for

set_vga()
set_pal(pal)
make_trigTb()

v={1,1,1}
dv={2,2,2}
frames=0
time1=time()
while get_key()=-1 do
 mem_cls(vscreen,0)
 --*** Rotate the points ***--
 points=rotate(points2,{1,1,1},v)
 faces={
  points[1..4],
  points[5..8],
  {points[1],points[2],points[6],points[5]},
  {points[6],points[2],points[3],points[7]},
  {points[4],points[3],points[7],points[8]},
  {points[1],points[5],points[8],points[4]}  
 }
 --*** Get the z-normals of the faces ***--
 zNormals=get_quad_zNormal(faces) 
 order=sort_faces(faces)
 faces=get_screen_xy({160,100},faces)
 for i=1 to 6 do
  --*** Is the face visible ? ***--
  if zNormals[order[i]]<0 then
   --*** This is where the shading is done                                   ***--
   --*** The formula is:                                                     ***--
   --*** span=abs(minZ-maxZ) (I used a value of 70 in this program)          ***--
   --*** shade=((center/4)+abs(minZ))/span                                   ***--
   --*** color=(number_of_shades-floor(number_of_shades*shade))+first_color  ***--             
   shade=((m19_centers[i]/4)+40)/70
   faceCol=(60-floor(60*shade))   
   asm_quad(faces[order[i]],1,faceCol,vscreen)
  end if
 end for
 wait_vrt()
 asm_copy_screen(vscreen,#A0000)
 frames=frames+1
 v=v+dv
 for i=1 to 3 do
  if v[i]>=361 then
   v[i]=1
  end if
  if v[i]<1 then
   v[i]=360
  end if
 end for
 --*** Randomize the rotating ***--
 if rand(150)=1 then
  dv=rand({6,6,6})-3
 end if
end while
time2=time()

restore_graphics()
free_asm_code()
free(vscreen)

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))
