include m19lib.e
include image.e

sequence img,pal,black_pal
sequence colors
atom t1,t2

--create a black palette
black_pal=repeat({0,0,0},256)

--load a bitmap, get the palette and poke the bitmap into memory
img=read_bitmap("images\\scrSpt.bmp")
pal=floor(img[1]/4)
colors=get_sprite_colors(img[2]) --get img's colors
img=poke_bitmap(img[2])

--set mode 19. set the palette
set_vga()
set_pal(black_pal)

--display the bitmap on the screen, scaled to 240*150
asm_sdisplay({40,25},img,{240,150},#A0000)

--delay for a while...
t1=time()
t2=0
while (t2-t1)<.5 do
t2=time()
end while

--fade from black to img's palette
black_pal=fade_to_pal(black_pal,pal,3)

--delay...
t1=time()
t2=0
while (t2-t1)<.5 do
t2=time()
end while

--change all the green in img to red
pal=sprite_swap_tone(pal,colors,2,1,5)

--delay...
t1=time()
t2=0
while (t2-t1)<.5 do
t2=time()
end while

--change all the red in img to blue
pal=sprite_swap_tone(pal,colors,1,3,5)

--delay...
t1=time()
t2=0
while (t2-t1)<.5 do
t2=time()
end while

--increase blue tone of img
pal=fade_sprite_towards_rgb(pal,colors,{0,0,63},9,5)

--delay...
t1=time()
t2=0
while (t2-t1)<.8 do
t2=time()
end while

--fade to black
pal=fade_to_rgb(pal,{0,0,0},3)

--free all asm code and the poked bitmap
free_asm_code()
free(img[1])

--restore graphics mode
restore_graphics()


puts(1,"***************************************\n")
puts(1,"*    m19lib demonstration by Mic      * \n")
puts(1,"*-------------------------------------*\n")
puts(1,"* Get m19lib at the Programming ZONE: *\n")
puts(1,"*-------------------------------------*\n")
puts(1,"*     http://come.to/progzone         *\n")
puts(1,"***************************************\n\n")
