-- gadgets.e
-- Jiri Babor
-- j.babor@gns.cri.nz

-- Version 1.10
-- Version 1.20
--    procedure rect() added.
--    sequence cs added.


global sequence cs   -- color sequence: top & left edge
                     --                 face
                     --                 bottom & right edge

global procedure rect(integer c, integer f, sequence s1, sequence s2)
   polygon(c,f,{s1,{s2[1],s1[2]},s2,{s1[1],s2[2]}})
end procedure  -- rect

global procedure frame(sequence s1, sequence s2)
   rect(cs[2],1,s1+1,s2-1)
   draw_line(cs[1],{{s1[1],s2[2]},s1,{s2[1],s1[2]}})
   draw_line(cs[3],{{s1[1]+1,s2[2]},s2,{s2[1],s1[2]+1}})
end procedure  -- frame

global procedure button(sequence s1, sequence s2, sequence label)
   frame(s1,s2)
   fy = floor((s1[2]+s2[2]-fheight())/2)+1
   fcprint(s1[1],s2[1],label)
end procedure   -- button

procedure delay(atom dt)
   atom t
   t=time()
   while time()-t<dt do
   end while
end procedure  -- delay

global procedure bounce(sequence xy1, sequence xy2)
   -- crude way of indicating a button was pressed: it displays a black
   -- rectangle around the button for 0.2 sec
   integer c1,c2
   c1=get_pixel(xy1)
   c2=get_pixel(xy2)
   rect(0,0,xy1,xy2)
   delay(0.2)
   draw_line(c1,{{xy1[1],xy2[2]},xy1,{xy2[1],xy1[2]}})
   draw_line(c2,{{xy1[1]+1,xy2[2]},xy2,{xy2[1],xy1[2]+1}})
end procedure  -- bounce

global procedure radio_button(integer c, integer st, sequence s)
   ellipse(15,1,s-4,s+4)
   ellipse(c,0,s-5,s+5)
   if st then
      ellipse(0,1,s-2,s+2)
   end if
end procedure  -- radio

-- defaults
cs = {15,7,8}
