--Remember to move m19lib.e into the euphoria\include folder before
--running this program
--This program takes a 320*200 image and scales it to different sizes
--It also shows examples of some palette manipulating routines

include m19lib.e
include image.e
include file.e
include graphics.e

without warning
without type_check

sequence thaPal,thaImg,thaImg2,thaImg3,thaImg4,thaImg5
sequence move,wS,tmp,img2col
sequence xy,cmd,crap
sequence clrs1,clrs2
atom vscreen,fpstime,fpstime2,fps
atom tm1,tm2
object junk
integer len1,len2,len3
fps=0  

--get command line
cmd=current_dir()  


--load images
thaImg=read_bitmap(cmd&"\\images\\scrSpt2.bmp")
thaImg2=read_bitmap(cmd&"\\images\\pic1.bmp")  
thaImg3=read_bitmap(cmd&"\\images\\pic2.bmp")  

--get the palette data
thaPal=floor(thaImg2[1]/4)  

--get the image data
thaImg=thaImg[2]
thaImg4=thaImg
thaImg2=thaImg2[2]  
thaImg3=thaImg3[2]
thaImg5=thaImg3

puts(1,"Wait while remapping colors...")

--align the sprite colors for sprite-fading
--the mapping will start at color 1 in this case
tm1=time()
tmp=remap_colors({thaImg,thaImg2,thaImg3,thaImg4,thaImg5},thaPal,1)
tm2=time()
thaPal=tmp[1]
thaImg=tmp[2][1]
thaImg2=tmp[2][2]
thaImg3=tmp[2][3]
thaImg4=tmp[2][4]
thaImg5=tmp[2][5]

--set mode 19
set_vga()


--change the tone of thaImg3 to dark cyan
tmp=get_sprite_colors(thaImg3)
thaPal=fade_sprite_towards_rgb(thaPal,tmp,{0,63,63},24,no_fading)
thaPal=fade_sprite_towards_rgb(thaPal,tmp,{0,0,0},24,no_fading)

--swap the green and blue tones of thaImg's colors
--this will make it blue instead of green
tmp=get_sprite_colors(thaImg)
thaPal=sprite_swap_tone(thaPal,tmp,2,3,no_fading)

--get thaImg2's colors for later
img2col=get_sprite_colors(thaImg2)
--thaPal=fade_sprite_tone_towards(thaPal,img2col,50,2,18,no_delay)
--thaPal=fade_sprite_tone_to(thaPal,img2col,0,1,no_delay)

--poke the images into memory
thaImg=poke_bitmap(thaImg)
thaImg2=poke_bitmap(thaImg2)  
thaImg3=poke_bitmap(thaImg3)
thaImg4=poke_bitmap(thaImg4)
thaImg5=poke_bitmap(thaImg5)

--set the palette
set_pal(thaPal)  

--allocate a virtual screen
vscreen=allocate(64000)  

--clear the virtual screen using color 0
mem_cls(vscreen,60)  

xy=repeat({0,0},200)  --the coordinates for the 200 sprites
move=repeat({0,0},200)  --the speed of wich the sprites are moving
wS=repeat(0,200)  --wich sprite to use (1 or 2)

for i=1 to 200 do
xy[i]={rand(319),rand(199)}  --initialize coords with random values
crap=rand({2,2})  --make the speed tables with random numbers
if crap[1]=1 then
move[i][1]=rand(3)
end if
if crap[1]=2 then
move[i][1]=-rand(3)
end if
if crap[2]=1 then
move[i][2]=-rand(3)
end if
if crap[2]=2 then
move[i][2]=rand(3)
end if
crap=rand({3,3})  --wich sprite is this gonna be, 1, 2 or 3 ?
if crap[1]=1 then
wS[i]=thaImg2
end if
if crap[1]=2 then
wS[i]=thaImg3
end if
if crap[1]=3 then
wS[i]=thaImg5
end if
end for


--get starting time
fpstime=time()  

--main program
while get_key()=-1 do  

--clear the virtual screen using color 0	
mem_cls(vscreen,0)

--display some sprites
asm_sdisplay({0,77},thaImg,{159,76},vscreen)
asm_sdisplay({160,100},thaImg4,{136,100},vscreen)
asm_sdisplay_clip({224,-10},thaImg4,{99,60},vscreen)

--display the first half of the scrolling sprites
for i=1 to 50 do  
asm_stdisplay_clip(xy[i],wS[i],{24,15},vscreen)  
end for
for i=51 to 100 do  
asm_tdisplay_clip(xy[i],wS[i],vscreen)  
end for

--display some more sprites
asm_stdisplay({1,0},thaImg4,{140,66},vscreen)
asm_stdisplay_clip({-285,80},thaImg4,{440,220},vscreen)
asm_stdisplay({134,32},thaImg,{120,100},vscreen)

--display the other half of the scrolling sprites
for i=101 to 150 do  
asm_tdisplay_clip(xy[i],wS[i],vscreen)  
end for
for i=151 to 200 do  
asm_stdisplay_clip(xy[i],wS[i],{24,15},vscreen)  
end for

--wait for vertical retrace
--Then copy vscreen to the real screen
wait_vrt()  
asm_copy_screen(vscreen,#A0000) 


--increment/decrement the coords with the speed tables
--if the sprites get too far off, reset them
for i=1 to 200 do
xy[i][1]=xy[i][1]+move[i][1]  
xy[i][2]=xy[i][2]+move[i][2]
if xy[i][1]>=350 then  
xy[i][1]=-50
end if
if xy[i][1]<=-52 then
xy[i][1]=330
end if
if xy[i][2]<=-23 then
xy[i][2]=205
end if
if xy[i][2]>=208 then
xy[i][2]=-21
end if
end for
fps=fps+1
end while

--get ending time
fpstime2=time()  


--free the poked sprites
free(thaImg[1])
free(thaImg2[1])  
free(thaImg3[1])
free(thaImg4[1])
free(thaImg5[1])

--deallocate the virtual screen
free(vscreen)  

--change all the red in thaImg2 to green
thaPal=sprite_swap_tone(thaPal,img2col,1,2,4)

--change all the green in thaImg2 to blue
thaPal=sprite_swap_tone(thaPal,img2col,2,3,4)

--increase red tone, decrease green and blue
thaPal=rgb_add(thaPal,{25,-5,-5},5)

--fade to black
thaPal=fade_to_rgb(thaPal,{0,0,0},3)  

--free the code for the display routines in m19lib
free_asm_code()

--reset graphics mode
restore_graphics()  

--print fps and some other crap
puts(1,"***************************************\n")
puts(1,"*    m19lib demonstration by Mic      * \n")
puts(1,"*-------------------------------------*\n")
puts(1,"* Get m19lib at the Programming ZONE: *\n")
puts(1,"*-------------------------------------*\n")
puts(1,"*     http://come.to/progzone         *\n")
puts(1,"***************************************\n\n")
puts(1,"fps: ")  
printf(1,"%d",(fps/(fpstime2-fpstime)))
puts(1,"\n")
puts(1,"remapping time: ")
print(1,(tm2-tm1))
puts(1,"s\n")

