--***                       Font routines used i m19lib                       ***--
--***                            Written 99 by Mic                            ***--
    
include file.e
include m19asm.e
include m19math.e


--*** Load a .f font into memory ***--
global function load_font(sequence filename)
sequence retSeq
atom fn
integer maxw,maxh
integer firstChar,lastChar,numChars
integer junk
atom fontMem
sequence fontBits
 fn=open(filename,"rb")
 if fn=-1 then
  return {-1,-1,-1,-1,-1}
 end if
 firstChar=getc(fn)
 lastChar=getc(fn)
 maxw=getc(fn) 
 maxh=getc(fn)
 maxw=maxw*8
 numChars=(lastChar-firstChar)+1
 fontMem=allocate((numChars*maxw*maxh)+numChars)
 if fontMem<=0 then
  return {-1,-1,-1,-1,-1}
 end if
 junk=getc(fn)
 junk=getc(fn)
 for i=1 to numChars do
  junk=getc(fn)
  poke(fontMem+(i-1),junk)
 end for
 for i=1 to numChars do
  for j=1 to maxh do
   for k=1 to (maxw/8) do
    junk=getc(fn)
    fontBits=byte2bits(junk)
    poke(fontMem+numChars+((i-1)*maxh*maxw)+((j-1)*maxw)+((k-1)*8),fontBits)
   end for
  end for
 end for
 retSeq={fontMem,firstChar,numChars,maxw,maxh}
 close(fn)
 return retSeq
end function


--*** Remove a loaded font from memory ***--
global procedure unload_font(sequence loaded_font)
 if (length(loaded_font)=5 and atom(loaded_font[1]) and loaded_font[1]>0) then
  free(loaded_font[1])
 end if
end procedure



--*** Print a text-string using given a font ***--
global procedure asm_text(sequence textCoords,sequence text,sequence textFont,integer textColor,atom textAddr)
integer currCharXdim
 poke(asm_char_color,textColor)
 poke(asm_char_ydim,textFont[5])
 textAddr=textAddr+(textCoords[2]*320)+textCoords[1]
 for i=1 to length(text) do
  currCharXdim=peek(textFont[1]+text[i])
  poke(asm_char_xdim,currCharXdim)
  poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5])))
  poke4(asm_char_scrAddr,textAddr)
  poke(asm_char_esiAdd,(textFont[4]-currCharXdim))
  poke4(asm_char_ediAdd,(320-currCharXdim))
  call(asm_char_code)
  textAddr=textAddr+currCharXdim
 end for
end procedure


--*** Same as the above but with clipping ***--
global procedure asm_text_clip(sequence textCoords,sequence text,sequence textFont,integer textColor,atom textAddr)
integer currCharXdim
integer txtXSub,txtYSub
 txtYSub=0
 txtXSub=0
 if (textCoords[2]<=199) then
  if (textCoords[2]+textFont[5]-1)>=0 then
   poke(asm_char_color,textColor)
   if textCoords[2]<0 then
    txtYSub=textCoords[2]
    textCoords[2]=0
    poke(asm_char_ydim,textFont[5]+txtYSub)
   else
    if (textCoords[2]+textFont[5]-1)>199 then
     txtYSub=(textCoords[2]+textFont[5]-1-199)
     poke(asm_char_ydim,textFont[5]-txtYSub)
    else
     poke(asm_char_ydim,textFont[5])
    end if
   end if
   textAddr=textAddr+(textCoords[2]*320)+textCoords[1]
   for i=1 to length(text) do
    if textCoords[1]<=319 then
     currCharXdim=peek(textFont[1]+text[i])
     if textCoords[1]<0 then
      if (textCoords[1]+currCharXdim-1)>=0 then
       txtXSub=-(textCoords[1])
       poke(asm_char_xdim,currCharXdim-txtXSub)
       if (txtYSub<0) then
        poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5]))-(txtYSub*textFont[4])+txtXSub)
       else
        poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5]))+txtXSub)
       end if
       poke4(asm_char_scrAddr,textAddr+txtXSub)
       poke(asm_char_esiAdd,(textFont[4]-currCharXdim)+txtXSub)
       poke4(asm_char_ediAdd,(320-currCharXdim)+txtXSub)
       call(asm_char_code)
       textAddr=textAddr+currCharXdim
       textCoords[1]=textCoords[1]+currCharXdim
      else
       textAddr=textAddr+currCharXdim
       textCoords[1]=textCoords[1]+currCharXdim     
      end if
     else
      if (textCoords[1]+currCharXdim-1)>319 then
       txtXSub=(textCoords[1]+currCharXdim-1-319)
       poke(asm_char_xdim,currCharXdim-txtXSub)
       if (txtYSub<0) then
        poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5]))-(txtYSub*textFont[4]))
       else
        poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5])))
       end if
       poke4(asm_char_scrAddr,textAddr)
       poke(asm_char_esiAdd,(textFont[4]-currCharXdim)+txtXSub)
       poke4(asm_char_ediAdd,(320-currCharXdim)+txtXSub)
       call(asm_char_code)
       textCoords[1]=textCoords[1]+currCharXdim
      else
       poke(asm_char_xdim,currCharXdim)
       if (txtYSub<0) then
        poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5]))-(txtYSub*textFont[4]))
       else
        poke4(asm_char_charAddr,(textFont[1]+textFont[3]+(text[i]*textFont[4]*textFont[5])))
       end if
       poke4(asm_char_scrAddr,textAddr)
       poke(asm_char_esiAdd,(textFont[4]-currCharXdim))
       poke4(asm_char_ediAdd,(320-currCharXdim))
       call(asm_char_code)
       textAddr=textAddr+currCharXdim
       textCoords[1]=textCoords[1]+currCharXdim
      end if
     end if
    end if
   end for
  end if
 end if
end procedure


--*** Write a single character using a given font ***--
global procedure asm_char(sequence coords,integer char,sequence font,integer color,atom scrAddr)
poke(asm_char_xdim,peek(font[1]+char))
poke(asm_char_ydim,font[5])
poke(asm_char_color,color)
poke4(asm_char_charAddr,(font[1]+font[3]+(char*font[4]*font[5])))
poke4(asm_char_scrAddr,scrAddr+(coords[2]*320)+coords[1])
poke(asm_char_esiAdd,(font[4]-peek(font[1]+char)))
poke4(asm_char_ediAdd,(320-peek(font[1]+char)))
call(asm_char_code)
end procedure


