--***                    Math/3d-stuff used by m19lib.                          ***--
--***                        Written 98/99 by Mic.            		        ***-- 


global constant vfix=3.14159265/180
global sequence cosTb, sinTb
global sequence m19_centers,m19_orderTb

constant zEye=-200

global integer minZ,maxZ
minZ=-50
maxZ=50


--*** Set up a trigonometric table ***--
global procedure make_trigTb()
 sinTb=repeat(0,360)
 cosTb=sinTb
 for i=1 to 360 do
  sinTb[i]=sin(i*vfix)
  cosTb[i]=cos(i*vfix)
 end for
end procedure


--*** Return the absolute value of num1 ***--
global function m19abs(integer num1)
if (num1<0) then
num1=-num1
end if
return num1
end function


--*** Return the differance between two integers ( diff(-1,2)=3 ) ***--
global function diff(integer num1,integer num2)
integer retNum
if (num1>=0) and (num2>=0) then
retNum=m19abs(num1-num2)
end if
if (num1>=0) and (num2<0) then
retNum=num1+m19abs(num2)
end if
if (num1<0) and (num2>=0) then
retNum=m19abs(num1)+num2
end if
if (num1<0) and (num2<0) then
retNum=m19abs(num1-num2)
end if
return retNum
end function


--*** Convert 3d-coordinates to 2d ***--
global function get_screen_xy(sequence xy,sequence obj)
integer x0,y0
integer numFaces,facePoints
sequence retSeq
 numFaces=length(obj)
 facePoints=length(obj[1])
 retSeq=repeat(repeat({0,0},facePoints),numFaces)
 for i=1 to numFaces do
  for j=1 to facePoints do
   x0=xy[1]+floor(obj[i][j][1]*(zEye/(zEye-obj[i][j][3])))
   y0=xy[2]+floor(obj[i][j][2]*(zEye/(zEye-obj[i][j][3])))
   retSeq[i][j]={x0,y0}
  end for
 end for
 return retSeq
end function



--*** Sort an array of faces ***--
global function sort_faces(sequence obj)
integer pos
atom tempval
integer numFaces,facePoints
 facePoints=length(obj[1])
 numFaces=length(obj)
 m19_centers=repeat(0,numFaces)
 m19_orderTb=m19_centers
 for i=1 to numFaces do
  for j=1 to facePoints do
   m19_centers[i]=m19_centers[i]+obj[i][j][3]
  end for
 end for
 for i=1 to numFaces do
  m19_orderTb[i]=i
 end for
 pos=1
 for i=1 to numFaces do
  for j=(i+1) to numFaces do
   if m19_centers[j]>m19_centers[i] then
    tempval=m19_centers[j]
    m19_centers[j]=m19_centers[i]
    m19_centers[i]=tempval
    tempval=m19_orderTb[j]
    m19_orderTb[j]=m19_orderTb[i]
    m19_orderTb[i]=tempval
   end if
  end for
 end for
return m19_orderTb
end function


--*** Rotate a sequence of points ***--
global function rotate(sequence obj,sequence toRotate,sequence a)
atom xr,yr,zr
integer objPoints
 objPoints=length(obj)
 for i=1 to objPoints do
  if toRotate[1]=1 then
   yr=(cosTb[a[1]]*obj[i][2])-(sinTb[a[1]]*obj[i][3])
   zr=(sinTb[a[1]]*obj[i][2])+(cosTb[a[1]]*obj[i][3])
   obj[i][2..3]={yr,zr}
  end if
  if toRotate[2]=1 then
   xr=(cosTb[a[2]]*obj[i][1])-(sinTb[a[2]]*obj[i][3])
   zr=(sinTb[a[2]]*obj[i][1])+(cosTb[a[2]]*obj[i][3])
   obj[i][1]=xr
   obj[i][3]=zr
  end if
  if toRotate[3]=1 then
   xr=(cosTb[a[3]]*obj[i][1])-(sinTb[a[3]]*obj[i][2])
   yr=(sinTb[a[3]]*obj[i][1])+(cosTb[a[3]]*obj[i][2])
   obj[i][1..2]={xr,yr}
  end if
 end for
 return obj
end function


global function get_quad_zNormal(sequence d3Coords)
sequence retNorm
integer numFaces
 numFaces=length(d3Coords) 
 retNorm=repeat(0,numFaces)
 for i=1 to numFaces do
  retNorm[i]=(d3Coords[i][1][3]+d3Coords[i][3][3])
 end for
return retNorm
end function


--*** Note: Does not give any proper results currently ***--
global function get_tri_zNormal(sequence d3Coords)
sequence retNorm
integer numFaces
 numFaces=length(d3Coords) 
 retNorm=repeat(0,numFaces)
 for i=1 to numFaces do
  retNorm[i]=(d3Coords[i][1][3]+d3Coords[i][3][3])
 end for
return retNorm
end function


--*** Convert a byte to a sequence of bits with the MSB first ***--
global function byte2bits(integer byte)
sequence retSeq
integer mask
 mask=128
 retSeq={0,0,0,0,0,0,0,0}
 for i=1 to 8 do
  if and_bits(byte,mask)>0 then
   retSeq[i]=1
  end if
 mask=floor(mask/2)
 end for
 return retSeq
end function
