--**                    Misc routines used by m19lib.                         ***--
--***                        Written 98/99 by Mic.         		      ***-- 

include m19asm.e

--*** Constants for use with the palette routines ***--
global constant no_fading=-666
global constant no_delay=-667

global sequence clip_box_coords
clip_box_coords={{0,0},{319,199}}
sequence outRegs,inRegs
outRegs={0,0,0,0,0,0,0,0,0,0}
inRegs=outRegs


--*** Set mode 19 ***--
global procedure set_vga()
outRegs={0,0,0,0,0,0,0,0,0,0}
outRegs[REG_AX]=#13
inRegs=dos_interrupt(#10,outRegs)
end procedure

--*** Restore graphics mode ***--
global procedure restore_graphics()
if machine_func(5,-1) then end if
end procedure


--*** Set the clip-box to the desired values ***--
global procedure set_clip_box(sequence tha_clip_coords)
if length(tha_clip_coords)=2 then
if length(tha_clip_coords[1])=2 then
if length(tha_clip_coords[1])=2 then
if tha_clip_coords[1][1]<tha_clip_coords[2][1] then
if tha_clip_coords[1][2]<tha_clip_coords[2][2] then
if tha_clip_coords[1][1]>=0 then
if tha_clip_coords[1][1]<318 then
if tha_clip_coords[1][2]>=0 then
if tha_clip_coords[1][2]<198 then
if tha_clip_coords[2][1]<=319 then
if tha_clip_coords[2][2]<=199 then
clip_box_coords=tha_clip_coords
end if
end if
end if
end if
end if
end if
end if
end if
end if
end if
end if
end procedure


global procedure asm_cls(atom tha_scr,integer tha_col)
tha_col=(tha_col*16777216)+(tha_col*65536)+(tha_col*256)+tha_col
poke4(cls_screen_addr,tha_scr)
poke4(asm_cls_color,tha_col)
call(asm_cls_code)
end procedure


global procedure asm_copy_screen(atom src,atom dest)
poke4(copy_dest_addr,dest)
poke4(copy_src_addr,src)
call(copy_screen_code)
end procedure


global procedure asm_scan_copy_screen(atom src,atom dest,integer scan_col)
poke4(scan_copy_dest,dest)
poke4(scan_copy_src,src)
poke4(scan_copy_color,scan_col+(scan_col*256)+(scan_col*65536)+(scan_col*16777216))
call(copy_screen_scan_code)
end procedure


global procedure asm_mask_copy_screen(atom src,atom dest,atom maskScr)
poke4(mask_copy_dest,dest)
poke4(mask_copy_src,src)
poke4(mask_copy_mask,maskScr)
call(copy_screen_mask_code)
end procedure


global procedure mem_cls(atom tha_screen_addr,integer tha_col)
mem_set(tha_screen_addr,tha_col,64000)
end procedure


global procedure mem_cls_clip(atom tha_screen_addr,integer tha_col)
integer cb_len
cb_len=(clip_box_coords[2][1]-clip_box_coords[1][1])+1
for i=clip_box_coords[1][2] to clip_box_coords[2][2] do
mem_set(tha_screen_addr+(i*320)+clip_box_coords[1][1],tha_col,cb_len)
end for
end procedure


global function poke_bitmap(sequence tha_bgf_img)
sequence ret_seq
atom tha_mem_space
tha_mem_space=allocate((length(tha_bgf_img)*length(tha_bgf_img[1])))
ret_seq=repeat(0,3)
for i=1 to length(tha_bgf_img) do
poke(tha_mem_space+(length(tha_bgf_img[1])*(i-1)),tha_bgf_img[i])
end for
ret_seq[1]=tha_mem_space
ret_seq[2]=length(tha_bgf_img[1])
ret_seq[3]=length(tha_bgf_img)
return ret_seq
end function


global procedure wait_vrt()
call(wait_vrt_code)
end procedure


global procedure short_wait_vrt()
call(short_wait_vrt_code)
end procedure


global procedure free_asm_code()
free(asm_disp_code)
free(asm_w_disp_code)
free(asm_d_disp_code)
free(asm_cdisp_code)
free(asm_tdisp_code)
free(asm_ctdisp_code)
free(asm_dispclip_code)
free(asm_w_dispclip_code)
free(asm_d_dispclip_code)
free(asm_cdispclip_code)
free(asm_tdispclip_code)
free(asm_ctdispclip_code)
free(asm_scale_disp_code)
free(asm_scale_tdisp_code)
free(asm_scale_disp_clip_code)
free(asm_scale_tdisp_clip_code)
free(copy_screen_code)
free(copy_screen_scan_code)
free(copy_screen_mask_code)
free(asm_cls_code)
free(wait_vrt_code)
free(short_wait_vrt_code)
free(asm_line_code)
free(asm_char_code)
free(hlines_code)
free(asm_box_code)
free(asm_xmin)
free(asm_xmax)
end procedure
