--***           Palette manipulation routines used by m19lib.                 ***--
--***                        Written 98/99 by Mic.         		      ***-- 
            
include ports.e
include m19misc.e

global function set_col(sequence tha_pal2,integer tha_col_num,sequence tha_pal)
Output(tha_col_num,#3C8)
Output(tha_pal[1],#3C9)
Output(tha_pal[2],#3C9)
Output(tha_pal[3],#3C9)
tha_pal2[tha_col_num+1]=tha_pal
return tha_pal2
end function


global procedure set_pal(sequence tha_pal)
for i=1 to 256 do
Output(i-1,#3C8)
Output(tha_pal[i][1],#3C9)
Output(tha_pal[i][2],#3C9)
Output(tha_pal[i][3],#3C9)
end for
end procedure


global function fade_to_rgb(sequence tha_pal_array,sequence to_rgb,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
   done_fading=0
   end if
  if tha_pal_array[i][j]<to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
   done_fading=0
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function


global function fade_towards_rgb(sequence tha_pal_array,sequence to_rgb,integer fade_steps,integer tha_delay)
for k=1 to fade_steps do
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
  end if
  if tha_pal_array[i][j]<to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end for
return tha_pal_array
end function


global function fade_sprite_towards_rgb(sequence tha_pal_array,sequence spt_pal,sequence to_rgb,integer fade_steps,integer tha_delay)
for k=1 to fade_steps do
 for i=1 to length(spt_pal) do
  for j=1 to 3 do
   if tha_pal_array[spt_pal[i]+1][j]>to_rgb[j] then
    tha_pal_array[spt_pal[i]+1][j]=tha_pal_array[spt_pal[i]+1][j]-1
   end if
   if tha_pal_array[spt_pal[i]+1][j]<to_rgb[j] then
    tha_pal_array[spt_pal[i]+1][j]=tha_pal_array[spt_pal[i]+1][j]+1
   end if
  end for
  if tha_delay!=no_fading then
  Output(spt_pal[i],#3C8)
  Output(tha_pal_array[spt_pal[i]+1][1],#3C9)
  Output(tha_pal_array[spt_pal[i]+1][2],#3C9)
  Output(tha_pal_array[spt_pal[i]+1][3],#3C9)
  end if
 end for
 if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
 --short_delay(tha_delay)
 for nnn=1 to tha_delay do
 wait_vrt()
 end for
 end if
end for
return tha_pal_array
end function

 
global function fade_to_pal(sequence tha_pal_array,sequence tha_goal_array,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>tha_goal_array[i][j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
   done_fading=0
   end if
  if tha_pal_array[i][j]<tha_goal_array[i][j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
   done_fading=0
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function


global function fade_tone_to(sequence tha_pal_array,integer tha_tone_goal,integer tha_tone_num,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
  if tha_pal_array[i][tha_tone_num]>tha_tone_goal then
  tha_pal_array[i][tha_tone_num]=tha_pal_array[i][tha_tone_num]-1
  done_fading=0
  end if
  if tha_pal_array[i][tha_tone_num]<tha_tone_goal then
   tha_pal_array[i][tha_tone_num]=tha_pal_array[i][tha_tone_num]+1
   done_fading=0
  end if
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function


global function fade_sprite_tone_to(sequence tha_pal_array,sequence sPal,integer tha_tone_goal,integer tha_tone_num,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to length(sPal) do
  if tha_pal_array[sPal[i]+1][tha_tone_num]>tha_tone_goal then
  if tha_pal_array[sPal[i]+1][tha_tone_num]>0 then
  tha_pal_array[sPal[i]+1][tha_tone_num]=tha_pal_array[sPal[i]+1][tha_tone_num]-1
  done_fading=0
  end if
  end if
  if tha_pal_array[sPal[i]+1][tha_tone_num]<tha_tone_goal then
   if tha_pal_array[sPal[i]+1][tha_tone_num]<63 then
   tha_pal_array[sPal[i]+1][tha_tone_num]=tha_pal_array[sPal[i]+1][tha_tone_num]+1
   done_fading=0
  end if
  end if
if tha_delay!=no_fading then
Output(sPal[i],#3C8)
Output(tha_pal_array[sPal[i]+1][1],#3C9)
Output(tha_pal_array[sPal[i]+1][2],#3C9)
Output(tha_pal_array[sPal[i]+1][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function



global function get_sprite_colors(sequence tha_sprite)
sequence ret_seq,cmp_seq
integer col_found
ret_seq={}
cmp_seq={0}
for i=1 to length(tha_sprite) do
 for j=1 to length(tha_sprite[1]) do
  col_found=0
  for k=1 to length(cmp_seq) do
   if tha_sprite[i][j]=cmp_seq[k] then
    col_found=1
   end if
  end for 
  if col_found=0 then
   ret_seq=ret_seq&tha_sprite[i][j]
   cmp_seq=cmp_seq&tha_sprite[i][j]
  end if
 end for
end for
return ret_seq
end function


global function remap_colors(sequence tha_img,sequence tha_pal,integer start_col)
sequence ret_seq,spt_clrs,tmp_pal,sc
sequence colors_found,col_tbl,cmp_seq
integer sptz,chgd,ll,base_col,col_found
sptz=length(tha_img)
sc=repeat(start_col,sptz)
tmp_pal=repeat({666,0,0},256)
spt_clrs=repeat(0,sptz)
base_col=start_col
for i=1 to sptz do
 col_tbl=repeat(0,256)
 colors_found={0}
 cmp_seq=colors_found
 for j=1 to length(tha_img[i]) do
  for k=1 to length(tha_img[i][1]) do
   col_found=0
   for l=1 to length(cmp_seq) do
    if tha_img[i][j][k]=colors_found[l] then
    col_found=1
   end if
   end for
    if col_found=0 then
    colors_found=colors_found&tha_img[i][j][k]
    col_tbl[tha_img[i][j][k]+1]=base_col
    base_col=base_col+1
   end if
   cmp_seq=colors_found
   ll=1
   chgd=0
   while (ll<=length(colors_found)) and (chgd=0) do
   --for l=1 to length(colors_found) do
    if (tha_img[i][j][k]=colors_found[ll]) and (colors_found[ll]!=0) then
     tmp_pal[col_tbl[tha_img[i][j][k]+1]+1]=tha_pal[tha_img[i][j][k]+1]
     tha_img[i][j][k]=col_tbl[tha_img[i][j][k]+1]
    chgd=1
    end if
   --end for
   ll=ll+1
   end while
  end for
 end for
end for
for i=1 to 256 do
 if tmp_pal[i][1]!=666 then
  tha_pal[i]=tmp_pal[i]
 end if
end for
ret_seq={tha_pal,tha_img}
return ret_seq
end function


global function swap_tone(sequence aPal,integer tn1,integer tn2,integer tha_delay)
sequence tmppal
integer tmpp,done_fading
tmppal=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=0 to 255 do
if aPal[i+1][tn1]<tmppal[i+1][tn2] then
if aPal[i+1][tn1]<63 then
done_fading=0
aPal[i+1][tn1]=aPal[i+1][tn1]+1
end if
end if
if aPal[i+1][tn1]>tmppal[i+1][tn2] then
if aPal[i+1][tn1]>0 then
done_fading=0
aPal[i+1][tn1]=aPal[i+1][tn1]-1
end if
end if
if aPal[i+1][tn2]<tmppal[i+1][tn1] then
if aPal[i+1][tn2]<63 then
done_fading=0
aPal[i+1][tn2]=aPal[i+1][tn2]+1
end if
end if
if aPal[i+1][tn2]>tmppal[i+1][tn1] then
if aPal[i+1][tn2]>0 then
done_fading=0
aPal[i+1][tn2]=aPal[i+1][tn2]-1
end if
end if
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[i+1][1],#3C9)
Output(aPal[i+1][2],#3C9)
Output(aPal[i+1][3],#3C9)
end if
end for
if tha_delay!=no_delay and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function



global function sprite_swap_tone(sequence aPal,sequence sPal,integer tn1,integer tn2,integer tha_delay)
sequence tmppal
integer tmpp,done_fading
 tmppal=aPal
 done_fading=0
 while done_fading=0 do
  done_fading=1
  for i=1 to length(sPal) do
   if aPal[sPal[i]+1][tn1]<tmppal[sPal[i]+1][tn2] then
    if aPal[sPal[i]+1][tn1]<63 then
     done_fading=0
     aPal[sPal[i]+1][tn1]=aPal[sPal[i]+1][tn1]+1
    end if
   end if
   if aPal[sPal[i]+1][tn1]>tmppal[sPal[i]+1][tn2] then
    if aPal[sPal[i]+1][tn1]>0 then
     done_fading=0
     aPal[sPal[i]+1][tn1]=aPal[sPal[i]+1][tn1]-1
    end if
   end if
   if aPal[sPal[i]+1][tn2]<tmppal[sPal[i]+1][tn1] then
    if aPal[sPal[i]+1][tn2]<63 then
     done_fading=0
     aPal[sPal[i]+1][tn2]=aPal[sPal[i]+1][tn2]+1
    end if
   end if
   if aPal[sPal[i]+1][tn2]>tmppal[sPal[i]+1][tn1] then
    if aPal[sPal[i]+1][tn2]>0 then
     done_fading=0
     aPal[sPal[i]+1][tn2]=aPal[sPal[i]+1][tn2]-1
    end if
   end if
--tmpp=aPal[sPal[i]+1][tn1]
--aPal[sPal[i]+1][tn1]=aPal[sPal[i]+1][tn2]
--aPal[sPal[i]+1][tn2]=tmpp
   if tha_delay!=no_fading then
    Output(sPal[i],#3C8)
    Output(aPal[sPal[i]+1][1],#3C9)
    Output(aPal[sPal[i]+1][2],#3C9)
    Output(aPal[sPal[i]+1][3],#3C9)
   end if
  end for
  if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
--short_delay(tha_delay)
   for nnn=1 to tha_delay do
    wait_vrt()
   end for
  end if
 end while
return aPal
end function


global function rgb_add(sequence aPal,sequence rgbAdd,integer tha_delay)
sequence tmpp
integer done_fading
tmpp=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=0 to 255 do
for j=1 to 3 do
if aPal[i+1][j]<(tmpp[i+1][j]+rgbAdd[j]) then
if aPal[i+1][j]<63 then
aPal[i+1][j]=aPal[i+1][j]+1
done_fading=0
end if
end if
if aPal[i+1][j]>(tmpp[i+1][j]+rgbAdd[j]) then
if aPal[i+1][j]>0 then
aPal[i+1][j]=aPal[i+1][j]-1
done_fading=0
end if
end if
end for
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[i+1][1],#3C9)
Output(aPal[i+1][2],#3C9)
Output(aPal[i+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function


global function sprite_rgb_add(sequence aPal,sequence sPal,sequence rgbAdd,integer tha_delay)
sequence tmpp
integer done_fading
tmpp=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to length(sPal) do
for j=1 to 3 do
if aPal[sPal[i]+1][j]<(tmpp[sPal[i]+1][j]+rgbAdd[j]) then
if aPal[sPal[i]+1][j]<63 then
aPal[sPal[i]+1][j]=aPal[sPal[i]+1][j]+1
done_fading=0
end if
end if
if aPal[sPal[i]+1][j]>(tmpp[sPal[i]+1][j]+rgbAdd[j]) then
if aPal[sPal[i]+1][j]>0 then
aPal[sPal[i]+1][j]=aPal[sPal[i]+1][j]-1
done_fading=0
end if
end if
end for
if tha_delay!=no_fading then
Output(sPal[i],#3C8)
Output(aPal[sPal[i]+1][1],#3C9)
Output(aPal[sPal[i]+1][2],#3C9)
Output(aPal[sPal[i]+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function



global function fade_tone_towards(sequence aPal,integer tone_goal,integer tone_num,integer tone_steps,integer tha_delay)
for i=1 to tone_steps do
for j=0 to 255 do
if aPal[j+1][tone_num]<tone_goal then
if aPal[j+1][tone_num]<63 then
aPal[j+1][tone_num]=aPal[j+1][tone_num]+1
end if
end if
if aPal[j+1][tone_num]>tone_goal then
if aPal[j+1][tone_num]>0 then
aPal[j+1][tone_num]=aPal[j+1][tone_num]-1
end if
end if
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[j+1][1],#3C9)
Output(aPal[j+1][2],#3C9)
Output(aPal[j+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end for
return aPal
end function


--*** Fade either red, green or blue in every color of the sprite towards the desired value ***--
global function fade_sprite_tone_towards(sequence aPal,sequence sPal,integer tone_goal,integer tone_num,integer tone_steps,integer tha_delay)
for i=1 to tone_steps do
for j=1 to length(sPal) do
if aPal[sPal[j]+1][tone_num]<tone_goal then
if aPal[sPal[j]+1][tone_num]<63 then
aPal[sPal[j]+1][tone_num]=aPal[sPal[j]+1][tone_num]+1
end if
end if
if aPal[sPal[j]+1][tone_num]>tone_goal then
if aPal[sPal[j]+1][tone_num]>0 then
aPal[sPal[j]+1][tone_num]=aPal[sPal[j]+1][tone_num]-1
end if
end if
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[sPal[j]+1][1],#3C9)
Output(aPal[sPal[j]+1][2],#3C9)
Output(aPal[sPal[j]+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end for
return aPal
end function


--*** Find the best match of tha_rgb in tha_pal ***--
function find_rgb(sequence tha_pal,sequence tha_rgb)
integer tmp,retVal,diffr
retVal=-1
diffr=63
for i=1 to 256 do
tmp=0
for j=1 to 3 do
tmp=tmp+diff(tha_pal[i][j],tha_rgb[j])
end for
tmp=floor(tmp/3)
if tmp<diffr then
retVal=(i-1)
diffr=tmp
end if
end for
return retVal
end function