--***               Primitive drawing routines used in m19lib                 ***--
--***                         Written 99 by Mic                               ***-- 

include m19math.e
include m19asm.e

global sequence xmax,xmin
global sequence umin,umax
global sequence vmin,vmax
sequence cmin,cmax

umin=repeat(0,200)
umax=umin
vmin=umin
vmax=umin


--*** Draw a line ***--
global procedure asm_line(sequence lineCoords,integer lineCol,atom lineDest)
integer screenOffset
integer deltax,deltay,numpixels
integer d,dinc1,dinc2
integer xinc1,xinc2
integer yinc1,yinc2
 deltax=m19abs(lineCoords[2][1]-lineCoords[1][1])
 deltay=m19abs(lineCoords[2][2]-lineCoords[1][2])
 if deltax>deltay then
  numpixels=deltax+1
  d=(2*deltay)-deltax
  dinc1=deltay*2
  dinc2=(deltay-deltax)*2
  xinc1=1
  xinc2=1
  yinc1=0
  yinc2=1
 else
  numpixels=deltay+1
  d=(2*deltax)-deltay
  dinc1=deltax*2
  dinc2=(deltax-deltay)*2
  xinc1=0
  xinc2=1
  yinc1=1
  yinc2=1
 end if
 if lineCoords[1][1] > lineCoords[2][1] then
  xinc1=-xinc1
  xinc2=-xinc2
 end if
 if lineCoords[1][2] > lineCoords[2][2] then
  yinc1=-yinc1
  yinc2=-yinc2
 end if
 screenOffset=(lineCoords[1][2]*320)+lineCoords[1][1]
 poke4(line_screenInc1,(yinc1*320)+xinc1-1)
 poke4(line_screenInc2,(yinc2*320)+xinc2-1)
 poke(line_color,lineCol)
 poke4(line_dest,(lineDest+screenOffset))
 poke4(line_dInc1,dinc1)
 poke4(line_dInc2,dinc2)
 poke4(line_d,d)
 poke4(line_numPixels,numpixels)
 call(asm_line_code)
end procedure


--*** Same as the above but with clipping ***--
global procedure asm_line_clip(sequence lineCoords,integer lineCol,atom lineDest)
integer screenOffset, noLine
integer deltax,deltay,numpixels
integer d,dinc1,dinc2
integer xinc1,xinc2
integer yinc1,yinc2
sequence tmp
noLine=0
if lineCoords[1][1]>lineCoords[2][1] then
 tmp=lineCoords[1]
 lineCoords[1]=lineCoords[2]
 lineCoords[2]=tmp
end if
if lineCoords[1][1]<0 then
 lineCoords[1][1]=0
end if
if (lineCoords[1][1]>319) or (lineCoords[2][1]<0) then
 noLine=1
end if
if lineCoords[2][1]>319 then
 lineCoords[2][1]=319
end if
if lineCoords[1][2]>lineCoords[2][2] then
 tmp=lineCoords[1]
 lineCoords[1]=lineCoords[2]
 lineCoords[2]=tmp
end if
if lineCoords[1][2]<0 then
 lineCoords[1][2]=0
end if
if lineCoords[2][2]>199 then
 lineCoords[2][2]=199
end if
if (lineCoords[1][2]>199) or (lineCoords[2][2]<0) then
 noLine=1
end if
if noLine=0 then
 deltax=m19abs(lineCoords[2][1]-lineCoords[1][1])
 deltay=m19abs(lineCoords[2][2]-lineCoords[1][2])
 if deltax>deltay then
  numpixels=deltax+1
  d=(2*deltay)-deltax
  dinc1=deltay*2
  dinc2=(deltay-deltax)*2
  xinc1=1
  xinc2=1
  yinc1=0
  yinc2=1
 else
  numpixels=deltay+1
  d=(2*deltax)-deltay
  dinc1=deltax*2
  dinc2=(deltax-deltay)*2
  xinc1=0
  xinc2=1
  yinc1=1
  yinc2=1
 end if
 if lineCoords[1][1] > lineCoords[2][1] then
  xinc1=-xinc1
  xinc2=-xinc2
 end if
 if lineCoords[1][2] > lineCoords[2][2] then
  yinc1=-yinc1
  yinc2=-yinc2
 end if
 screenOffset=(lineCoords[1][2]*320)+lineCoords[1][1]
 poke4(line_screenInc1,(yinc1*320)+xinc1-1)
 poke4(line_screenInc2,(yinc2*320)+xinc2-1)
 poke(line_color,lineCol)
 poke4(line_dest,(lineDest+screenOffset))
 poke4(line_dInc1,dinc1)
 poke4(line_dInc2,dinc2)
 poke4(line_d,d)
 poke4(line_numPixels,numpixels)
 call(asm_line_code)
 end if
end procedure


--*** Draw a hollow quadangle ***--
global procedure asm_hollow_quad(sequence pCoords,integer pCol,atom pAddr)
 for i=1 to 3 do
  asm_line_clip({pCoords[i],pCoords[i+1]},pCol,pAddr)
 end for
 asm_line_clip({pCoords[4],pCoords[1]},pCol,pAddr)
end procedure


--*** Draw a hollow triangle ***--
global procedure asm_hollow_tri(sequence pCoords,integer pCol,atom pAddr)
 for i=1 to 2 do
  asm_line_clip({pCoords[i],pCoords[i+1]},pCol,pAddr)
 end for
 asm_line_clip({pCoords[3],pCoords[1]},pCol,pAddr)
end procedure


--*** Draw a triangle ***--
global procedure asm_tri(sequence polyCoords,integer polyStyle,integer polyCol,atom polyAddr)
integer fracBits
integer yMin,yMax
integer xMin,xMax
integer dX1,dX2,dX3
integer xP1,xP2,xP3
integer tmp,dont
 if polyStyle=0 then
  asm_hollow_tri(polyCoords,polyCol,polyAddr)
 else
 fracBits=16
 yMin=polyCoords[1][2]
 yMax=yMin
 if (polyCoords[2][2]<yMin) then
  yMin=polyCoords[2][1]
  polyCoords[2][1]=polyCoords[1][1]
  polyCoords[1][1]=yMin
  yMin=polyCoords[2][2]
  polyCoords[2][2]=polyCoords[1][2]
  polyCoords[1][2]=yMin
 end if
 if (polyCoords[2][2]>yMax) then
  yMax=polyCoords[2][2]
 end if
 if (polyCoords[3][2]<yMin) then
  yMin=polyCoords[3][1]
  polyCoords[3][1]=polyCoords[1][1]
  polyCoords[1][1]=yMin
  yMin=polyCoords[3][2]
  polyCoords[3][2]=polyCoords[1][2]
  polyCoords[1][2]=yMin
 end if
 if (polyCoords[3][2]>yMax) then
  yMax=polyCoords[3][2]
 end if
 if (polyCoords[3][2]<polyCoords[2][2]) then
  tmp=polyCoords[3][1]
  polyCoords[3][1]=polyCoords[2][1]
  polyCoords[2][1]=tmp
  tmp=polyCoords[3][2]
  polyCoords[3][2]=polyCoords[2][2]
  polyCoords[2][2]=tmp
 end if
 xP1=(polyCoords[1][1]*65536)
 xP2=(polyCoords[1][1]*65536)
 xP3=(polyCoords[2][1]*65536)
 dont=0
 if polyCoords[2][2]=polyCoords[1][2] then
  dont=1
 else
  dX1=floor(((polyCoords[2][1]-polyCoords[1][1])*65536)/(polyCoords[2][2]-polyCoords[1][2]))
 end if
 if polyCoords[3][2]=polyCoords[1][2] then
  dont=2
 else
  dX2=floor(((polyCoords[3][1]-polyCoords[1][1])*65536)/(polyCoords[3][2]-polyCoords[1][2]))
 end if
 if polyCoords[3][2]=polyCoords[2][2] then
  dont=3
 else
  dX3=floor(((polyCoords[3][1]-polyCoords[2][1])*65536)/(polyCoords[3][2]-polyCoords[2][2]))
 end if
 for i=yMin to yMax do
  xMin=32000
  xMax=-32000
  if (i<=polyCoords[2][2]) and (dont!=1) then
   xMin=floor(xP1/65536)
   xMax=xMin
   xP1=xP1+dX1
  end if
  if (i<=polyCoords[3][2]) and (dont!=2) then
   tmp=floor(xP2/65536)
   if tmp<xMin then
    xMin=tmp
   end if
   if tmp>xMax then
    xMax=tmp
   end if
   xP2=xP2+dX2
  end if
  if (i>=polyCoords[2][2]) and (dont!=3) then
   tmp=floor(xP3/65536)
   if tmp<xMin then
    xMin=tmp
   end if
   if tmp>xMax then
    xMax=tmp
   end if
   xP3=xP3+dX3
  end if
  if xMin<0 then
   xMin=0
  end if
  if xMax>319 then
   xMax=319
  end if
  if (xMin<=319) and (xMax>=xMin) and (i>=0) and (i<=199) then
   mem_set(polyAddr+(i*320)+xMin,polyCol,xMax-xMin+1)  
  end if
 end for
end if
end procedure


--*** Draw a hollow box ***--
procedure asm_hollow_box(sequence bCoords,integer bCol,atom bAddr)
 asm_line({bCoords[1],{bCoords[2][1],bCoords[1][2]}},bCol,bAddr)
 asm_line({{bCoords[2][1],bCoords[1][2]},bCoords[2]},bCol,bAddr)
 asm_line({{bCoords[1][1],bCoords[2][2]},bCoords[2]},bCol,bAddr)
 asm_line({bCoords[1],{bCoords[1][1],bCoords[2][2]}},bCol,bAddr)
end procedure


--*** Draw a box ***--
global procedure asm_box(sequence boxCoords,integer boxStyle,integer boxCol,atom boxAddr)
integer tmp
if boxStyle=0 then
 asm_hollow_box(boxCoords,boxCol,boxAddr)
else
 if boxCoords[1][1]>boxCoords[2][1] then
  tmp=boxCoords[1][1]
  boxCoords[1][1]=boxCoords[2][1]
  boxCoords[2][1]=tmp
 end if
 if boxCoords[1][2]>boxCoords[2][2] then
  tmp=boxCoords[1][2]
  boxCoords[1][2]=boxCoords[2][2]
  boxCoords[2][2]=tmp
 end if
 poke4(asm_boxAddr,boxAddr+(boxCoords[1][2]*320)+boxCoords[1][1])
 poke4(asm_box_xDim,(boxCoords[2][1]-boxCoords[1][1])+1)
 poke4(asm_box_yDim,(boxCoords[2][2]-boxCoords[1][2])+1)
 poke(asm_boxCol,boxCol)
 poke4(asm_box_add,319-(boxCoords[2][1]-boxCoords[1][1]))
 call(asm_box_code)
end if
end procedure


--*** Draw a hollow box, with clipping ***--
procedure asm_hollow_box_clip(sequence bCoords,integer bCol,atom bAddr)
 asm_line_clip({bCoords[1],{bCoords[2][1],bCoords[1][2]}},bCol,bAddr)
 asm_line_clip({{bCoords[2][1],bCoords[1][2]},bCoords[2]},bCol,bAddr)
 asm_line_clip({{bCoords[1][1],bCoords[2][2]},bCoords[2]},bCol,bAddr)
 asm_line_clip({bCoords[1],{bCoords[1][1],bCoords[2][2]}},bCol,bAddr)
end procedure


--*** Draw a box, with clipping ***--
global procedure asm_box_clip(sequence boxCoords,integer boxStyle,integer boxCol,atom boxAddr)
integer tmp, noBox
if boxStyle=0 then
 asm_hollow_box_clip(boxCoords,boxCol,boxAddr)
else
 if boxCoords[1][1]>boxCoords[2][1] then
  tmp=boxCoords[1][1]
  boxCoords[1][1]=boxCoords[2][1]
  boxCoords[2][1]=tmp
 end if
 if boxCoords[1][2]>boxCoords[2][2] then
  tmp=boxCoords[1][2]
  boxCoords[1][2]=boxCoords[2][2]
  boxCoords[2][2]=tmp
 end if
 noBox=0
 if (boxCoords[1][1]>319 or boxCoords[2][1]<0) then
  noBox=1
 end if
 if (boxCoords[1][2]>199 or boxCoords[2][2]<0) then
  noBox=1
 end if
 if noBox=0 then
  if boxCoords[1][1]<0 then
   boxCoords[1][1]=0
  end if
  if boxCoords[1][2]<0 then
   boxCoords[1][2]=0
  end if
  if boxCoords[2][1]>319 then
   boxCoords[2][1]=319
  end if
  if boxCoords[2][2]<199 then
   boxCoords[2][2]=199
  end if 
  poke4(asm_boxAddr,boxAddr+(boxCoords[1][2]*320)+boxCoords[1][1])
  poke4(asm_box_xDim,(boxCoords[2][1]-boxCoords[1][1])+1)
  poke4(asm_box_yDim,(boxCoords[2][2]-boxCoords[1][2])+1)
  poke(asm_boxCol,boxCol)
  poke4(asm_box_add,319-(boxCoords[2][1]-boxCoords[1][1]))
  call(asm_box_code)
 end if
end if
end procedure



procedure scan_poly_side(sequence sideCoords)
integer deltax,deltay,numpixels
integer d,dinc1,dinc2
integer x,xinc1,xinc2
integer y,yinc1,yinc2
 deltax=m19abs(sideCoords[2][1]-sideCoords[1][1])
 deltay=m19abs(sideCoords[2][2]-sideCoords[1][2])
 if deltax>deltay then
  numpixels=deltax+1
  d=(deltay+deltay)-deltax
  dinc1=deltay+deltay
  dinc2=(deltay-deltax)*2
  xinc1=1
  xinc2=1
  yinc1=0
  yinc2=1
 else
  numpixels=deltay+1
  d=(deltax+deltax)-deltay
  dinc1=deltax+deltax
  dinc2=(deltax-deltay)*2
  xinc1=0
  xinc2=1
  yinc1=1
  yinc2=1
 end if
 if sideCoords[1][1] > sideCoords[2][1] then
  xinc1=-xinc1
  xinc2=-xinc2
 end if
 if sideCoords[1][2] > sideCoords[2][2] then
  yinc1=-yinc1
  yinc2=-yinc2
 end if
 x=sideCoords[1][1]
 y=sideCoords[1][2]
 for i=1 to numpixels do
  if x<xmin[y+1] then
   xmin[y+1]=x
  end if
  if x>xmax[y+1] then
   xmax[y+1]=x
  end if
  if d < 0 then
   d=d+dinc1
   x=x+xinc1
   y=y+yinc1
  else
   d=d+dinc2
   x=x+xinc2
   y=y+yinc2
  end if
 end for
end procedure


--*** Draw a quadangle ***--
global procedure asm_quad(sequence quadCoords,integer quadStyle,integer quadCol,atom quadAddr)
integer ymin,ymax
integer ii
 if quadStyle=0 then
  asm_hollow_quad(quadCoords,quadCol,quadAddr)
 else
  xmin=repeat(8000,200)
  xmax=repeat(-8000,200)
  scan_poly_side(quadCoords[1..2])
  scan_poly_side(quadCoords[2..3])
  scan_poly_side(quadCoords[3..4])
  scan_poly_side({quadCoords[4],quadCoords[1]})
  ymin=quadCoords[1][2]
  ymax=ymin
  for i=2 to 4 do
   if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
   if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
  end for 
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  for i=ymin to ymax do
   ii=i+1
   if (xmin[ii]<=319 and xmax[ii]>=0) then
    if xmin[ii]<0 then xmin[ii]=0 end if
    if xmax[ii]>319 then xmax[ii]=319 end if
     mem_set(quadAddr+(i*320)+xmin[ii],quadCol,(xmax[ii]-xmin[ii])+1)
   end if
  end for
end if
end procedure


--*** Draw a hollow (convex) n-sided polygon ***--
global procedure asm_hollow_polygon(sequence pCoords,integer pCol,atom pAddr)
 for i=1 to length(pCoords)-1 do
  asm_line_clip({pCoords[i],pCoords[i+1]},pCol,pAddr)
 end for
 asm_line_clip({pCoords[length(pCoords)],pCoords[1]},pCol,pAddr)
end procedure


--*** Draw a (convex) n-sided polygon ***--
global procedure asm_polygon(sequence polyCoords,integer polyStyle,integer polyCol,atom polyAddr)
integer ymin,ymax
 if polyStyle=0 then
  asm_hollow_polygon(polyCoords,polyCol,polyAddr)
 else
  xmin=repeat(8000,200)
  xmax=repeat(-8000,200)
  for i=1 to length(polyCoords)-1 do
   scan_poly_side(polyCoords[i..i+1])
  end for
  scan_poly_side({polyCoords[length(polyCoords)],polyCoords[1]})
  ymin=polyCoords[1][2]
  ymax=ymin
  for i=2 to length(polyCoords) do
   if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
   if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
  end for 
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  for i=ymin to ymax do
    if (xmin[i]<=319 and xmax[i]>=0) then
     if xmin[i]<0 then xmin[i]=0 end if
     if xmax[i]>319 then xmax[i]=319 end if
     mem_set(polyAddr+(i*320)+xmin[i],polyCol,(xmax[i]-xmin[i])+1)
   end if
  end for
end if
end procedure


 
 