--***                   Sprite routines used by m19lib.                       ***--
--***                        Written 98/99 by Mic.         		      ***-- 


include m19math.e
include m19asm.e
include m19misc.e

global procedure asm_display(sequence coords,sequence tha_img,atom tha_screen_addr)
integer odd_byte
 odd_byte=tha_img[2]-(floor(tha_img[2]/2)*2)
if floor(tha_img[2]/4)=(tha_img[2]/4) then
 poke4(d_asm_disp_x,coords[1])
 poke(d_asm_disp_y,coords[2])
 poke(d_bmp_xdim,(tha_img[2]/4))
 poke(d_bmp_ydim,tha_img[3])
 poke4(d_disp_offs_add,(320-tha_img[2]))
 poke4(d_bmp_img_addr,(tha_img[1]))
 poke4(d_disp_screen_addr,tha_screen_addr)
 call(asm_d_disp_code)
else if odd_byte=0 then
 poke4(w_asm_disp_x,coords[1])
 poke(w_asm_disp_y,coords[2])
 poke(w_bmp_xdim,(tha_img[2]/2))
 poke(w_bmp_ydim,tha_img[3])
 poke4(w_disp_offs_add,(320-tha_img[2]))
 poke4(w_bmp_img_addr,(tha_img[1]))
 poke4(w_disp_screen_addr,tha_screen_addr)
 call(asm_w_disp_code)
else
 poke4(asm_disp_x,coords[1])
 poke(asm_disp_y,coords[2])
 poke(bmp_xdim,floor(tha_img[2]/2))
 poke(bmp_ydim,tha_img[3])
 poke4(disp_offs_add,(320-tha_img[2]))
 poke4(bmp_img_addr,(tha_img[1]))
 poke4(disp_screen_addr,tha_screen_addr)
 poke(odd_pixel,odd_byte)
 call(asm_disp_code)
end if
end if
end procedure


global procedure asm_cdisplay(sequence coords,sequence tha_img,integer tha_col,atom tha_screen_addr)
poke4(asm_cdisp_x,coords[1])
poke(asm_cdisp_y,coords[2])
poke(cbmp_xdim,floor(tha_img[2]/2))
poke(cbmp_ydim,tha_img[3])
poke4(cdisp_offs_add,(320-tha_img[2]))
poke4(cdisp_screen_addr,tha_screen_addr)
poke4(c_color,(tha_col*256)+tha_col)
poke(codd_pixel,tha_img[2]-(floor(tha_img[2]/2)*2))
call(asm_cdisp_code)
end procedure


global procedure asm_sdisplay(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
poke4(asm_sdisp_x,coords[1])
poke(asm_sdisp_y,coords[2])
poke4(sbmp_xdim,spt_dims[1])
poke(sbmp_ydim,spt_dims[2])
poke4(sspriteXdims,tha_img[2])
poke4(sbmp_img_addr,tha_img[1])
poke4(sdisp_offs_add,(320-spt_dims[1]))
poke4(sdisp_screen_addr,tha_screen_addr)
poke4(spriteXstep,floor((tha_img[2]/spt_dims[1])*32768))
poke4(spriteYstep,floor(((tha_img[3]/spt_dims[2]))*32768))
call(asm_scale_disp_code)
end procedure


global procedure asm_stdisplay(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
poke4(asm_stdisp_x,coords[1])
poke(asm_stdisp_y,coords[2])
poke4(stbmp_xdim,spt_dims[1])
poke(stbmp_ydim,spt_dims[2])
poke4(stspriteXdims,tha_img[2])
poke4(stbmp_img_addr,tha_img[1])
poke4(stdisp_offs_add,(320-spt_dims[1]))
poke4(stdisp_screen_addr,tha_screen_addr)
poke4(tspriteXstep,floor((tha_img[2]/spt_dims[1])*32768))
poke4(tspriteYstep,floor(((tha_img[3]/spt_dims[2]))*32768))
call(asm_scale_tdisp_code)
end procedure


global procedure asm_tdisplay(sequence coords,sequence tha_img,atom tha_screen_addr)
poke4(asm_tdisp_x,coords[1])
poke(asm_tdisp_y,coords[2])
poke4(tbmp_xdim,tha_img[2])
poke(tbmp_ydim,tha_img[3])
poke4(tdisp_offs_add,(320-tha_img[2]))
poke4(tbmp_img_addr,(tha_img[1]))
poke4(tdisp_screen_addr,tha_screen_addr)
call(asm_tdisp_code)
end procedure


global procedure asm_ctdisplay(sequence coords,sequence tha_img,integer tha_col,atom tha_screen_addr)
poke4(asm_ctdisp_x,coords[1])
poke(asm_ctdisp_y,coords[2])
poke4(ctbmp_xdim,tha_img[2])
poke(ctbmp_ydim,tha_img[3])
poke4(ctdisp_offs_add,(320-tha_img[2]))
poke4(ctbmp_img_addr,(tha_img[1]))
poke4(ctdisp_screen_addr,tha_screen_addr)
poke(ct_color,tha_col)
call(asm_ctdisp_code)
end procedure


global procedure asm_display_clip(sequence coords,sequence tha_img,atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
integer odd_byte
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then


 odd_byte=xLen-(floor(xLen/2)*2)
if floor(xLen/4)=(xLen/4) then
 poke4(d_asm_dispclip_x,clipX)
 poke(d_asm_dispclip_y,clipY)
 poke(d_clipbmp_xdim,floor(xLen/4))
 poke(d_clipbmp_ydim,yLen)
 poke4(d_dispclip_offs_add,(320-xLen))
 poke4(d_clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(d_dispclip_screen_addr,tha_screen_addr)
 poke4(d_clipimg_offs_add,clipOffsAdd)
 call(asm_d_dispclip_code)
else if odd_byte=0 then
 poke4(w_asm_dispclip_x,clipX)
 poke(w_asm_dispclip_y,clipY)
 poke(w_clipbmp_xdim,floor(xLen/2))
 poke(w_clipbmp_ydim,yLen)
 poke4(w_dispclip_offs_add,(320-xLen))
 poke4(w_clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(w_dispclip_screen_addr,tha_screen_addr)
 poke4(w_clipimg_offs_add,clipOffsAdd)
 call(asm_w_dispclip_code)
else
 poke4(asm_dispclip_x,clipX)
 poke(asm_dispclip_y,clipY)
 poke(clipbmp_xdim,floor(xLen/2))
 poke(clipbmp_ydim,yLen)
 poke4(dispclip_offs_add,(320-xLen))
 poke4(clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(dispclip_screen_addr,tha_screen_addr)
 poke4(clipimg_offs_add,clipOffsAdd)
 call(asm_dispclip_code)
end if
end if
end if
end procedure


global procedure asm_sdisplay_clip(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
integer no_disp,esi_add
integer xLen,yLen
atom xstep,ystep
xstep=(tha_img[2]/spt_dims[1])
ystep=(tha_img[3]/spt_dims[2])
no_disp=0
esi_add=0
xLen=spt_dims[1]
yLen=spt_dims[2]
if coords[1]<clip_box_coords[1][1] then
if (coords[1]+spt_dims[1]-1)<clip_box_coords[1][1] then
no_disp=1
else
esi_add=esi_add+floor(xstep*diff(coords[1],clip_box_coords[1][1]))
xLen=xLen-diff(coords[1],clip_box_coords[1][1])
coords[1]=0
end if
end if
if coords[2]<clip_box_coords[1][2] then
if (coords[2]+spt_dims[2]-1)<clip_box_coords[1][2] then
no_disp=1
else
esi_add=esi_add+floor((tha_img[2]*ystep*diff(coords[2],clip_box_coords[1][2]))/tha_img[2])*tha_img[2]
yLen=yLen-diff(coords[2],clip_box_coords[1][2])
coords[2]=0
end if
end if
spt_dims={xLen,yLen}
if (coords[1]+spt_dims[1]-1)>clip_box_coords[2][1] then
if coords[1]>clip_box_coords[2][1] then
no_disp=1
else
xLen=xLen-diff((coords[1]+spt_dims[1]-1),clip_box_coords[2][1])
end if
end if
if (coords[2]+spt_dims[2]-1)>clip_box_coords[2][2] then
if coords[2]>clip_box_coords[2][2] then
no_disp=1
else
yLen=yLen-diff((coords[2]+spt_dims[2]-1),clip_box_coords[2][2])
end if
end if
spt_dims={xLen,yLen}
if no_disp=0 then
poke4(asm_scdisp_x,coords[1])
poke(asm_scdisp_y,coords[2])
poke4(scbmp_xdim,spt_dims[1])
poke(scbmp_ydim,spt_dims[2])
poke4(scspriteXdims,tha_img[2])
poke4(scbmp_img_addr,tha_img[1]+esi_add)
poke4(scdisp_offs_add,(320-spt_dims[1]))
poke4(scdisp_screen_addr,tha_screen_addr)
poke4(cspriteXstep,floor(xstep*32768))
poke4(cspriteYstep,floor(ystep*32768))
call(asm_scale_disp_clip_code)
end if
end procedure


global procedure asm_stdisplay_clip(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
integer no_disp,esi_add
integer xLen,yLen
atom xstep,ystep
xstep=(tha_img[2]/spt_dims[1])
ystep=(tha_img[3]/spt_dims[2])
no_disp=0
esi_add=0
xLen=spt_dims[1]
yLen=spt_dims[2]
if coords[1]<clip_box_coords[1][1] then
if (coords[1]+spt_dims[1]-1)<clip_box_coords[1][1] then
no_disp=1
else
esi_add=esi_add+floor(xstep*diff(coords[1],clip_box_coords[1][1]))
xLen=xLen-diff(coords[1],clip_box_coords[1][1])
coords[1]=clip_box_coords[1][1]
end if
end if
if coords[2]<clip_box_coords[1][2] then
if (coords[2]+spt_dims[2]-1)<clip_box_coords[1][2] then
no_disp=1
else
esi_add=esi_add+floor((tha_img[2]*ystep*diff(coords[2],clip_box_coords[1][2]))/tha_img[2])*tha_img[2]
yLen=yLen-diff(coords[2],clip_box_coords[1][2])
coords[2]=clip_box_coords[1][2]
end if
end if
spt_dims={xLen,yLen}
if (coords[1]+spt_dims[1]-1)>clip_box_coords[2][1] then
if coords[1]>clip_box_coords[2][1] then
no_disp=1
else
xLen=xLen-diff((coords[1]+spt_dims[1]-1),clip_box_coords[2][1])
end if
end if
if (coords[2]+spt_dims[2]-1)>clip_box_coords[2][2] then
if coords[2]>clip_box_coords[2][2] then
no_disp=1
else
yLen=yLen-diff((coords[2]+spt_dims[2]-1),clip_box_coords[2][2])
end if
end if
spt_dims={xLen,yLen}
if no_disp=0 then
poke4(asm_stcdisp_x,coords[1])
poke(asm_stcdisp_y,coords[2])
poke4(stcbmp_xdim,spt_dims[1])
poke(stcbmp_ydim,spt_dims[2])
poke4(stcspriteXdims,tha_img[2])
poke4(stcbmp_img_addr,tha_img[1]+esi_add)
poke4(stcdisp_offs_add,(320-spt_dims[1]))
poke4(stcdisp_screen_addr,tha_screen_addr)
poke4(tcspriteXstep,floor(xstep*32768))
poke4(tcspriteYstep,floor(ystep*32768))
call(asm_scale_tdisp_clip_code)
end if
end procedure


global procedure asm_cdisplay_clip(sequence coords,sequence tha_img,integer cColor,
atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then
poke4(asm_cdispclip_x,clipX)
poke(asm_cdispclip_y,clipY)
poke(cclipbmp_xdim,floor(xLen/2))
poke(cclipbmp_ydim,yLen)
poke4(cdispclip_offs_add,(320-xLen))
poke4(cclip_color,(cColor*256)+cColor)
poke4(cdispclip_screen_addr,tha_screen_addr)
poke(cclip_odd_pixel,xLen-(floor(xLen/2)*2))
call(asm_cdispclip_code)
end if
end procedure


global procedure asm_tdisplay_clip(sequence tcoords,sequence ttha_img,atom ttha_screen_addr)
integer tbmpXdim,tbmpYdim,txEnd,tyEnd
integer tclippedXdim,tclippedYdim
integer tclipX,tclipY,txLen,tyLen
integer tstartOffsAdd,tclipOffsAdd,tnoDisp
tbmpXdim=(ttha_img[2])
tbmpYdim=(ttha_img[3])
txLen=tbmpXdim
tyLen=tbmpYdim
tstartOffsAdd=0
tclipOffsAdd=0
tclipX=tcoords[1]
tclipY=tcoords[2]
txEnd=(tcoords[1]+tbmpXdim-1)
tyEnd=(tcoords[2]+tbmpYdim-1)
tnoDisp=0
if tcoords[1]<clip_box_coords[1][1] then
if txEnd<clip_box_coords[1][1] then
tnoDisp=1
end if
tclipX=clip_box_coords[1][1]
tstartOffsAdd=tclipX-tcoords[1]
tclipOffsAdd=tstartOffsAdd
txLen=txLen-tstartOffsAdd
end if
if tcoords[2]<clip_box_coords[1][2] then
if tyEnd<clip_box_coords[1][2] then
tnoDisp=1
end if
tclipY=clip_box_coords[1][2]
tstartOffsAdd=tstartOffsAdd+((tclipY-tcoords[2])*tbmpXdim)
tyLen=tyLen-(tclipY-tcoords[2])
end if
if (tcoords[1]>clip_box_coords[2][1]) or (tcoords[2]>clip_box_coords[2][2]) then
tnoDisp=1
end if
if txEnd>clip_box_coords[2][1] then
txLen=txLen-(txEnd-clip_box_coords[2][1])
tclipOffsAdd=tclipOffsAdd+(txEnd-clip_box_coords[2][1])
end if
if tyEnd>clip_box_coords[2][2] then
tyLen=tyLen-(tyEnd-clip_box_coords[2][2])
end if
if (tnoDisp=0) then
poke4(asm_tdispclip_x,tclipX)
poke(asm_tdispclip_y,tclipY)
poke4(tclipbmp_xdim,txLen)
poke(tclipbmp_ydim,tyLen)
poke4(tdispclip_offs_add,(320-txLen))
poke4(tclipbmp_img_addr,(ttha_img[1])+tstartOffsAdd)
poke4(tdispclip_screen_addr,ttha_screen_addr)
poke4(tclipimg_offs_add,tclipOffsAdd)
call(asm_tdispclip_code)
end if
end procedure


global procedure asm_ctdisplay_clip(sequence coords,sequence tha_img,integer ctColor,
atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then
poke4(asm_ctdispclip_x,clipX)
poke(asm_ctdispclip_y,clipY)
poke4(ctclipbmp_xdim,xLen)
poke(ctclipbmp_ydim,yLen)
poke4(ctdispclip_offs_add,(320-xLen))
poke(ctclip_color,ctColor)
poke4(ctdispclip_screen_addr,tha_screen_addr)
poke4(ctclipbmp_img_addr,tha_img[1]+startOffsAdd)
poke4(ctclipimg_offs_add,clipOffsAdd)
call(asm_ctdispclip_code)
end if
end procedure


